unit UnidadGUsuario;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, forms, ComCtrls,
  variants, windows, ZDataset, dxCntner, dxEditor, dxExEdtr, dxEdLib,
  dxDBELib, Mask;

type
  TformGUsuario = class(TForm)
    BAceptar: TBitBtn;
    Panel1: TPanel;
    txtCodigo: TDBEdit;
    lCodigo: TLabel;
    Label8: TLabel;
    txtFecha: TdxDBDateEdit;
    Label2: TLabel;
    txtNick: TDBEdit;
    BCancelar: TBitBtn;
    txtNombre: TDBEdit;
    Label1: TLabel;
    opMod: TDBCheckBox;
    opAdmin: TDBCheckBox;
    Label3: TLabel;
    txtContrasena1: TDBEdit;
    DBCheckBox3: TDBCheckBox;
    Label4: TLabel;
    txtEmail: TDBEdit;
    Label10: TLabel;
    txtCodigoDepartamento: TDBEdit;
    bSelDepartamento: TSpeedButton;
    txtDepartamento: TLabel;
    procedure BCancelarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure txtNombreEnter(Sender: TObject);
    procedure txtNombreExit(Sender: TObject);
    procedure txtCodigoEnter(Sender: TObject);
    procedure txtCodigoExit(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure txtFechaEnter(Sender: TObject);
    procedure txtFechaExit(Sender: TObject);
    procedure txtNickExit(Sender: TObject);
    procedure txtNickEnter(Sender: TObject);
    procedure txtContrasena1Enter(Sender: TObject);
    procedure txtContrasena1Exit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bSelDepartamentoClick(Sender: TObject);
    procedure txtCodigoDepartamentoEnter(Sender: TObject);
    procedure txtCodigoDepartamentoExit(Sender: TObject);
    procedure txtCodigoDepartamentoKeyPress(Sender: TObject;
  var Key: Char);


  private
    { Private declarations }
    contrasenaActual : string;
  public
    { Public declarations }
  end;

var
  formGUsuario: TformGUsuario;
const
  ventana = 'Usuario';
  ventanas = 'Usuarios';


implementation


uses UnidadModuloDatos, UnidadProcedimientos, UnidadSeleccion;

var
  tTabla : TZTable;

{$R *.DFM}

procedure TformGUsuario.BCancelarClick(Sender: TObject);
begin
  try
    ttabla.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TformGUsuario.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ttabla.Close;
  action := cafree;
end;

procedure TformGUsuario.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformGUsuario.FormShow(Sender: TObject);
begin
  if vtAccion = 'zoom' then
    BCancelar.SetFocus
  else
    txtFecha.SetFocus;
end;


procedure TformGUsuario.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //cambiar el foco con las teclas de cursor
  if (Key in [VK_UP, VK_DOWN]) and
      Not (ActiveControl is TDBComboBox) and not (ActiveControl is TDBMemo) then
  begin
    if Key = VK_UP then
      Perform(WM_NEXTDLGCTL, 1, 0)
    else
      Perform(WM_NEXTDLGCTL, 0, 0);
    Key := 0;
  end;
end;

procedure TformGUsuario.txtNombreEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGUsuario.txtNombreExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGUsuario.txtCodigoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGUsuario.txtCodigoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGUsuario.BAceptarClick(Sender: TObject);
begin
  //si el cdigo no se genera automticamente comprobar que est introducido
  if txtCodigo.Visible then
  begin
    if txtCodigo.Text = '' then
    begin
      MessageDlg ('El campo Cdigo debe tener un valor.', mtWarning, [mbok], 0);
      TxtCodigo.setfocus;
      exit;
    end;
  end;

  if txtNick.Text = '' then
  begin
    MessageDlg ('El campo Nick debe tener un valor.', mtWarning, [mbok], 0);
    txtNick.setfocus;
    exit;
  end;

  if txtNombre.Text = '' then
  begin
    MessageDlg ('El campo Nombre debe tener un valor.', mtWarning, [mbok], 0);
    txtNombre.setfocus;
    exit;
  end;

  //si se ha cambiado la contrasea
  if contrasenaActual <> txtContrasena1.Text then
    txtContrasena1.Text := AnsiLowerCase(obtenerHash(txtContrasena1.Text));

  if ttabla.State  in [dsinsert, dsedit] then
  begin
    try
      txtContrasena1.Text := txtContrasena1.Text;
      ttabla.Post; //validar
      close;
    except
      txtFecha.setfocus;
      raise;
    end;
  end;
end;

procedure TformGUsuario.txtFechaEnter(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clMoneyGreen;
end;

procedure TformGUsuario.txtFechaExit(Sender: TObject);
begin
  TdxDBDateEdit(sender).Color := clWindow;
end;

procedure TformGUsuario.txtNickExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGUsuario.txtNickEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGUsuario.txtContrasena1Enter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGUsuario.txtContrasena1Exit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
end;

procedure TformGUsuario.FormCreate(Sender: TObject);
begin
  tTabla := md.tUsuario;
  ttabla.Active := true;
  if vtAccion = 'nuevo' then
  begin
    contrasenaActual := '';
    caption := 'Aadir ' + ventana + '...';
    lCodigo.Visible := false;
    txtCodigo.Visible := false;
    tTabla.Insert;
    tTabla.FieldByName('codusuarioa').AsInteger := vtCodigoUsuario;
    tTabla.FieldByName('fechaa').AsDateTime := Now;
    tTabla.FieldByName('fecha').AsDateTime := Now;
    tTabla.FieldByName('administrador').AsString := 'N';
    tTabla.FieldByName('modificacion').AsString := 'N';
    tTabla.FieldByName('accesoweb').AsString := 'N';
  end;

  if vtAccion = 'modificar' then
  begin
    ttabla.locate ('Codigo', vtCodigo, []);
    caption := 'Modificacin de ' + ventana + '...';
    tTabla.Edit;
    tTabla.FieldByName('codusuariom').AsInteger := vtCodigoUsuario;
    tTabla.FieldByName('fecham').AsDateTime := Now;
    contrasenaActual := tTabla.fieldbyname('contrasena').asString;
    txtDepartamento.Caption :=
          obtenerNombre(tTabla.FieldByName('codigodepartamento').AsInteger,
          vtTablaDepartamento);
  end;

  if vtAccion = 'zoom' then
  begin
    tTabla.locate ('Codigo', vtCodigo, []);
    caption := 'Visualizacin de ' + ventana + '...';
    baceptar.Visible := false;
    txtDepartamento.Caption :=
          obtenerNombre(tTabla.FieldByName('codigodepartamento').AsInteger,
          vtTablaDepartamento);
  end;
end;

procedure TformGUsuario.bSelDepartamentoClick(Sender: TObject);
begin
  txtCodigoDepartamento.SetFocus;
  application.createform(tformseleccion, formseleccion);
  formseleccion.ActNuevo.Enabled := true;
  formseleccion.tag := vtNumDepartamento;
  formseleccion.ShowModal;
  if vtClaveElegida <> 0 then
    tTabla.FieldByName ('codigodepartamento').AsInteger := vtClaveElegida;
end;

procedure TformGUsuario.txtCodigoDepartamentoEnter(Sender: TObject);
begin
  TEdit(sender).Color := clMoneyGreen;
end;

procedure TformGUsuario.txtCodigoDepartamentoExit(Sender: TObject);
begin
  TEdit(sender).Color := clWindow;
  txtDepartamento.Caption :=
      obtenerNombre(tTabla.FieldByName('codigodepartamento').AsInteger,
      vtTablaDepartamento);
end;

procedure TformGUsuario.txtCodigoDepartamentoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    bSelDepartamentoClick(nil);
  end;
end;

end.
