unit UnidadProcedimientos;

interface
  uses inifiles, sysutils, ShlObj, ActiveX, Windows, ShellCtrls,
      controls, classes, registry, db, dialogs, forms, variants, IdSMTP,
      IdMessage, dateutils, shellapi, mapi, LbClass, LbCipher,
      LbUtils, aes, base64, StrUtils;

  function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
  function leCadINI (clave, cadena : string; defecto : String) : String;
  function leNumINI (clave, cadena : string; defecto : Integer) : Integer;
  procedure esCadINI (clave, cadena : string; valor : String);
  procedure esBoolINI (clave, cadena : string; valor : Boolean);
  procedure esNumINI (clave, cadena : string; valor : Integer);
  function SeleccionarCarpeta (titulo : string) : string;
  procedure cargarConfiguracion ();
  function encriptar (Str, Clave : String) : String;
  function desencriptar (Str, Clave : String) : String;
  function obtenerCadenaRegistro (claveInicial : Cardinal; clave : string; valor : string) : string;
  procedure obtenerDatosODBC (odbc : string; sistema : boolean;
      var bd : string; var tipo : string; var descripcion : string;
      var controlador : string; var servidor : string;
      var listener : string; var usuario : string);
  procedure conectarBD ();
  function comprobarDuplicado (nombre : string; tabla : string; campo : string) : boolean;
  function insertarvalor (valor : string; tabla : string) : integer;
  function obtenerValor (campo : string; tabla : string; valor : Integer) : string;
  procedure actualizarStock (entrada : boolean; cantidad : double; codigo : Integer);
  function obtenerNombre (codigo : integer; tabla : string) : string;
  function generarCodigoAuto (tabla : string) : integer;
  function ConectarServidorEmail (servidor : string; usuario : string; puerto : integer) : boolean;
  function enviarEmail (servidor : string; usuario : string; contrasena : string;
      puerto : integer; asunto : string; mensaje : TStringList; conAutenticacion : boolean;
      emisor : string; nombreEmisor : string; destinatario : string; cc : string) : boolean;
  function obtenerEmail (codigo : integer; tabla : string; campo : string) : string;
  function obtenerMySQLTablas () : TStringList;
  function actualizarParteFacturado (codigo : integer; facturado,
      numerofactura : string; codigofactura : integer) : boolean;
  function tamanoFichero (sFileToExamine: string) : Integer;
  function obtenerNumeroFactura () : string;
  function anoFecha (fecha : TDate) : Integer;
  function obtenerPrecioHoraCliente (codigo : integer; var porcDto : Double; var desplazamiento : double) : Double;
  function obtenerPrecioArticulo (codigo : integer; var nombreMaterial : string) : Double;
  function existeRegistro (tabla : string; campo : string; valor : integer) : boolean;
  function obtenerEmailContacto (codigo : integer) : string;
  function obtenerDatosUsuario (codigo : integer;
      var email : string; var nombre : string) : boolean;
  function comprobarIntegridad (tabla : string; campo : string;
      codigo : integer) : boolean;
  function marcarTelefono (telefono : string; puerto : string) : boolean;
  procedure colgarLlamada ();
  function ejecutarProceso (nombreProceso : string) : Cardinal;
  procedure ejecutarEsperar (aplicacion : string);
  procedure obtenerValorParametro (nombre : string;
      var valor1 : string; var valor2 : string);
  function obtenerDiasVtoCliente (codigo : integer) : Integer;
  function cargarSeries (tabla : string) : TStringList;
  function llenarCadena (cadena : string; numero : integer; caracter : Char;
     derecha : Boolean) : string;
  procedure insertarAdjunto (nombreTabla : string; codigoBus : string; fichero : string);
  function enviarEmailClientePredeterminado (const asunto, cuerpo,
      rutaFicheroAdjunto, nombreEmisor, emailEmisor,
                  nombreReceptor, emailReceptor : string) : integer;
  function permisoAccesoMenu (opcionMenu : Integer; avisar : boolean) : boolean;
  function permisoModificacion (opcion : string; avisar : boolean) : boolean;
  function eliminarClaveRegistro (clave : string; claveRoot : Cardinal) : boolean;
  procedure reestablecerValoresTabla (ventana : string);
  function mostrarNumSerie (serie : string; tablaM : string) : Boolean;
  function obtenerHash (texto : string) : string;
  function permisosMenuUsuario (codigousuario, codigomenu,
      tipoPermiso : integer; mostrarAviso : boolean) : boolean;
  procedure insertarLogIncidencia (codigoUsuarioAlta : integer; accion : string;
      fecha : TDateTime; codigoIncidencia : integer; fechaInicio : TDateTime;
      fechaFin : TDateTime; valorTexto : string;
      valorNumerico : integer;    automatico : string; observacion : string);
  procedure incidenciaResolver (codigoIncidencia : integer;
      textoResolucion : string; motivoResolucion : string; fechaResolucion : TDate;
      horaResolucion : TTime; tiempoEmpleado : integer);
  procedure enviarEmailEstadoIncidencia (codigoIncidencia : integer;
      tipo : string; mostrarFormulario : boolean; departamentoTecnico : boolean);
  procedure incidenciaReabrir (codigoIncidencia : integer;
      textoResolucion : string);
  function obtenerDepartamentoTecnicoSubcategoria (codigo : integer) : integer;
  procedure incidenciaAceptar (codigoIncidencia : integer);
  function establecerPrioridadIncidencia (codigoUsuario,
      codigoSubcategoria, codigoIncidencia : Integer) : integer;    
  procedure incidenciaDesestimar (codigoIncidencia : integer;
      textoResolucion : string);
  function tiempoTotalTareasIncidencia (codigoInciencia : integer) : Integer;
  function extraerNickUsuario (codigo : integer) : string;
  function usuarioMostrarSusIncidencias (codigo : integer) : boolean;
  procedure incidenciaCambiarEstado (codigoIncidencia : integer; estado : string);
  function incidenciaObtenerDepartamentoUsuario (codigoIncidencia : integer) : string;
  function usuarioEsTecnico (codigo : integer) : boolean;
  function departamentoEsTecnico (codigo : integer) : boolean;
  procedure obtenerCategoriaSubcategoriaRecurso (codigoRecurso : integer;
      var codigoCategoria : integer; var codigoSubcategoria : integer);
  procedure horasMinutosSegundos (numSegundos : integer; var horas,
      minutos, segundos : integer);
  procedure incidenciaConfirmar (codigoIncidencia : integer);
  procedure incidenciaCambiarTecnicoAsignado (codigoIncidencia : integer;
    codigoTecnico : integer; codigoDepartamento : integer;
    aceptada : boolean);  procedure incidenciaAvisada (codigoIncidencia : integer);
  function subcategoriaPerteneceCategoria (codigoSubcategoria : integer;
    codigoCategoria : integer) : boolean;
  function obtenerUsuarioIncidencia (codigoIncidencia : integer) : integer;
  function usuarioPerteneceDepartamento (codigoUsuario : integer;
    codigoDepartamento : integer) : boolean;
  function obtenerCampo (codigo : integer; tabla : string;
    campo : string) : string;
  function asignarIncidenciaAuto (codigoIncidencia : integer;
    codigoUsuarioExcluir : integer; codigoSubcategoria : integer) : integer;
  function obtenerTiempoMedioResolucionIncidencia (
    codigoIncidencia : integer) : integer;
  function listaCategoriasSubcategorias (categoriasPrincipio : boolean;
    categoriasSubcategorias : Boolean) : TStringList;
  procedure actualizarTiempoMedioSubcategoria (codigoIncidencia : integer);
  function obtenerDepartamentoUsuario (codigoUsuario : integer) : string;
  function anosMesesDias(fechaInicio : TDate; fechaFin : TDate) : string;
  function listaMotivosResolucion (incidencia : integer) : TStringList;
  procedure quitarUsuarioDepartamento (codigoUsuario : integer;
      codigoDepartamento : integer);
  procedure insertarUsuarioDepartamento (codigoUsuario : integer;
      codigoDepartamento : integer);
  function unSoloTecnicoDepartamento (codigoDepartamento : integer) : integer;
  procedure actualizarRecursoSiAutomatico (codigoUsuario : integer);
  function obtenerRecursoUsuario (codigoUsuario : integer) : integer;
  function generarNumeroSerie (serie, tabla : string;
      anio : integer) : string;
  function obtenerTipoSolicitud (todas : Boolean) : TStringList;
  function obtenerSerieIncidencia (tipo : string) : string;
  function generarReferenciaIncidencia (tipoSolicitud, tabla : string;
    anio : integer) : String;
  function existenDocumentos (ventana : string; codigo : integer) : boolean;
  procedure crearReferenciasIncidencias ();
  procedure escribeRegistro (desdeClave : HKEY; ruta, cadena, valor : string;
      crear : boolean);
//  function cargarPerfilesTelefonos () : TStringList;
  procedure actualizarListaHistoricoTelefonos (codigo : integer);
  function incidenciaObtenerCodigoDepartamentoUsuario (codigoIncidencia : integer) : integer;
  function separarEmailLista (emails : string) : TStringList;
  function obtenerLista (tabla : string; campo : string) : TStringList;


var
  vtVersionAplicacion : string;
  vtUsuarioAcceso : string;
  vtContrasenaUsuario : string;
  vtAdministradorUsuario : boolean;
  vtnombreUsuario : string;
  vtUsuarioTipo : string;
  vtModificacionUsuario : boolean;
  vtClienteUsuario : integer;
  vtCodigoUsuario : integer;
  vtSuperUsuario : string;
  vtSoloIncidenciasUsuario : boolean;
  vtRutaMDBInventario : string;
  vtContrasenaMDB : string;

  vtUsuario : string; //usuario para acceso a la BD (si no se ha marcado Pedir Usuario
  vtContrasena : string;  //contrasea para acceso a la BD (si no se ha marcado Pedir Usuario
  vtTipoBDMySQL : boolean;
  vtDefectoTipo : String; //guarda el tipo de tercero por defecto (proveedor, cliente, otro)
  vtDefectoCambioControl : Boolean; //permitir cambiar de foco con la tecla Intro
  vtDuplicadoNombreArticulo : Boolean; //permitir duplicados del nombre del artculo
  vtDuplicadoNombreTercero : Boolean; //permitir duplicados del nombre del tercero
  vtBDMySQLNombreBD : string; //nombre de la base de datos
  vtBDMySQLServidor : string; //nombre/ip del servidor donde est alojada la BD
  vtBDMySQLPuerto : string;  //puerto utilizado para conexin a MySQL
  vtBDMySQLProtocolo : string; //versin de MySQL que se utilizar, admite Oracle
  vtBDMySQLPedirUsuario : boolean; //mostrar ventana de peticin de usuario y contrasea para acceso a la BD

  vtClaveElegida : integer; //aqu se almacenar el cdigo del registro seleccionado en la ventana de seleccin
  vtClaveElegidaT : String; //valor de tipo texto seleccionado en la ventana de seleccin
  vtClaveElegidaT2 : String; //valor de tipo texto seleccionado en la ventana de seleccin

  vtCodigoSel : integer; //cdigo seleccionado del registro para la ventana de seleccin
  vtCodigoCategoriaSel : integer; //cdigo subcategora para mostrar slo las subcategoras de la categora
  vtCodigoMarcaSel : integer; //cdigo marca para mostrar slo los modelos de la marca

  vtAccion : string; //para la ventana de modificacin, insercin, visualizacin (acciones)
  vtCodigo: integer; //almacena el cdigo del registro a visualizar
  vtCodigo2: integer; //almacena el cdigo del registro a visualizar  
  vtCodigoTexto : string; //almacena el cdigo del registro a visualizar (texto)
  vtIndeterminado: string; //almacena el valor por defecto para un campo indeterminado

  vtCrearFacturaAuto : boolean; //crea la factura automticamente mostrando la ventana de insercin de artculos
                                //como cdigo de cliente por defecto utiliza vtCodigoClienteFacturas
  vtCodigoClienteFacturas : integer; //cdigo de cliente por defecto en facturas
  vtCodigoProveedorFacturas : integer; //cdigo de proveedor por defecto en facturas
  vtPorcentajeIVAFactura : integer;

  vtArticulosCodFamilia : integer;
  vtArticulosCodModelo : integer;
  vtArticulosCodMarca : integer;
  vtArticulosCodProveedor : integer;
  vtCodT1 : integer;
  vtCodT2 : integer;
  vtCodT3 : integer;
  vtCodT4 : integer;
  vtCodT5 : integer;
  vtCodT6 : integer;
  vtCodTecnicoInd : integer;
  vtDefectoCodRecurso : integer;
  vtDefectoCodUsuario : integer;
  vtDefectoCodCliente : integer;
  vtDefectoPrioridad : integer;
  vtDefectoIncidenciaTipo : String;
  vtTamanoFicheroAdjunto : integer;
  vtCantidadCarFac : integer;
  vtSerieFactura : String;
  vtAnoFactura : String;
  vtOrdenNumFactura : array[1..3] of Integer;
  vtOcultarPieFactura : boolean;
  vtOcultarPieObservacion : boolean;
  vtFacturasSerie : string;


  vtEmpresaNombre : string;
  vtEmpresaDireccion : string;
  vtEmpresaCIF : string;
  vtEmpresaProvincia : string;
  vtEmpresaPoblacion : string;
  vtEmpresaNombrePersona : string;
  vtEmpresaTelefono : string;
  vtEmpresaInscripcion : string;
  vtEmpresaLogotipo : String;
  vtEmpresaLogotipoNombre : String;
  vtEmpresaCP : string;
  vtEmpresaObservacion : string;

  vtEmailServidor : string;
  vtEmailUsuario : string;
  vtEmailContrasena : string;
  vtEmailPuerto : string;
  vtEmailCuenta : string;
  vtEmailAutenticacion : Boolean;

  vtTituloVentanaPartesTrabajo : string;
  vtTituloVentanaIncidencias : string;
  vtTituloVentanaPartesTrabajoPlural : string;
  vtTituloVentanaIncidenciasPlural : string;
  vtTituloVentanaPartesTrabajoBoton : string;
  vtTituloVentanaPartesTrabajoMenu : string;

  vtColorIncidenciaPrioridadAlta : Integer;
  vtColorIncidenciasPrioridadMedia : Integer;
  vtColorIncidenciasPrioridadBaja : Integer;
  vtColorIncidenciasFuenteSeleccionada : Integer;
  vtColorIncidenciasFuenteNoSeleccionada : Integer;
  vtColorIncidenciasPorFuente : boolean;
  vtColorIncidenciasSeleccion : integer;
  vtColorIncidenciaReaperturas : integer;

  //carpeta y ejecutable de aplicacin AjpdSoft Informacin Usuarios Terminal Server
  vtRutaAplicacionControlRemoto : string;

  //mostrar aviso antes de confirmar una incidencia por el tcnico asociado
  vtIncidenciaAvisoConfirmar : boolean;
  //per
  vtIncidenciaReasignarAsociado : boolean;

  //para seleccionar tercero
  vtCodigoTerceroFactura : integer;

  //para marcacin telefnica
  ficheroComunicacion : THandle;

  vtNotificacionMostrada : boolean;
  vtTiempoComprobacionNotificacion : integer;
  vtNotificarIncidenciasNuevas : boolean;
  vtAvisoIncidenciasUnaVez : boolean;

  //incidencias
  vtIncidenciaEnviarEmail : boolean;
  vtIncidenciaAsignacionAutomatica : boolean;
  vtIncidenciaAnadirOtra : boolean;

  vtIncidenciaMostrarFechaInferior : boolean; //filtrar incidencias por ao
  vtNumMesesMostrarIncidencias : integer;  

  vtCodigoLog : integer;

  vtCodigoTemp : integer;

const
  //nombre de las tablas de la aplicacin
  vtTablaTercero = 'tercero';
  vtTablaArticulo = 'material';
  vtTablaFactura = 'factura';
  vtTablaCobro = 'cobro';
  vtTablaMarca = 'marca';
  vtTablaModelo = 'modelo';
  vtTablaGenero = 'genero';
  vtTablaRango = 'rango';
  vtTablaFamilia = 'familia';
  vtTablaFacturaDetalle = 'facturadetalle';
  vtTablaParte = 'partetrabajo';
  vtTablaParteDetalle = 'partetrabajodetalle';
  vtTablaParteMaterial = 'partetrabajomaterial';
  vtTablaFacturaProveedorDetalle = 'facturaproveedordetalle';
  vtTablaFacturaProveedor = 'facturaproveedor';
  vtTablaPago = 'pago';
  vtTablaGasto = 'gasto';
  vtTablaContador = 'contador';
  vtTablaSQL = 'consultasql';
  vtTablaIncidencia = 'incidencia';
  vtTablaContacto = 'contacto';
  vtTablaRecurso = 'recurso';
  vtTablaTipoGasto = 'tipogasto';
  vtTablaNota = 'nota';
  vtTablaCaja = 'caja';
  vtTablaDominio = 'dominio';
  vtTablaUsuario = 'usuario';
  vtTablaAlbaranProveedor = 'albaranproveedor';
  vtTablaAlbaranProveedorDetalle = 'albaranproveedordetalle';
  vtTablaEjercicio = 'ejercicio';
  vtTablaChequePagare = 'chequepagare';
  vtTablaDatosSeguros = 'contrasena';
  vtTablaPresupuesto = 'presupuesto';
  vtTablaDocumento = 'documento';
  vtTablaParametro = 'parametro';
  vtTablaFormaPago = 'formapago';
  vtTablaSerie = 'serie';
  vtTablaTelefono = 'telefono';
  vtTablaDepartamento = 'departamento';
  vtTablaUbicacion = 'ubicacion';
  vtTablaUsuarioMenu = 'usuariomenu';
  vtTablaMenu = 'menu';
  vttablaCategoria = 'categoria';
  vttablaSubCategoria = 'subcategoria';
  vtTablaIncidenciasLog = 'incidenciaslog';
  vtTablaDepartamentoUsuarios = 'departamentousuarios';
  vtTablaEntradaSalida = 'entradasalida';
  vtTablaTelefonoFijo = 'telefonofijo';
  vtTablaIncidenciaResolucion = 'incidenciaresolucion';
  vtTablaRegistroCopias = 'registrocopias';
  vtTablaIncidenciaTipo = 'incidenciatipo';
  vtTablaAccesoDirecto = 'accesodirecto';
  vtTablaTelefonoPerfil = 'telefonoperfil';
  vtTablaTelefonoTerminalLog = 'telefonousuario';
  vtTablaDispositivo = 'invdispositivo';
  vtTablaTipoDispositivo = 'invtipodispositivo';
  vtTablaEquipo = 'inv_puesto';
  vtTablaPrestamoMaterial = 'prestamomaterial';

  //tag para ventana de seleccin
  vtNumTipoGasto = 1;
  vtNumProveedor = 10;
  vtNumDispositivo = 11;
  vtNumUtilidadesBD = 12;
  vtNumPrestamoMaterial = 13;
  vtNumEquipo = 14;
  vtNumFormaPago = 15;
  vtNumCliente = 20;
  vtNumCategoria = 25;
  vtNumArticulo = 30;
  vtNumSubcategoria = 35;
  vtNumDominio = 40;
  vtNumDepartamento = 45;
  vtNumDepartamentoTecnico = 48;
  vtNumMarca = 50;
  vtNumEjecucionSQL = 55;
  vtNumTelefono = 60;
  vtNumcontador = 65;
  vtNumTelefonoPerfil = 70;
  vtNumModelo = 80;
  vtNumUbicacion = 85;
  vtNumFamilia = 90;
  vtNumSeguridadMenus = 95;
  vtNumFacturaLinea = 110;
  vtCuadroMando = 115;
  vtNumFactura = 120;
  vtNumEntradaSalida = 125;
  vtNumGasto = 130;
  vtNumTelefonoFijo = 135;
  vtNumCobro = 140;
  vtNumRegistroCopias = 145;
  vtNumPago = 150;
  vtNumParte = 160;
  vtNumTecnico = 180;
  vtNumIncidencia = 190;
  vtNumIncidenciaMotivoResolucion = 195;
  vtNumContacto = 200;
  vtNumIncidenciaTipo = 205;
  vtNumTercero = 210;
  vtNumRecurso = 220;
  vtNumNota = 230;
  vtNumCaja = 240;
  vtNumUsuario = 250;
  vtNumAlbaranProveedor = 260;
  vtNumEjercicio = 270;
  vtNumChequePagare = 280;
  vtNumSerie = 291;



  vtClaveRegistroConfiguracion = '\Software\AjpdSoft\Gestin NNTT\';

  vtPermisoLectura = 1;
  vtPermisoModificacion = 2;
  vtPermisoInsercion = 3;
  vtPermisoEliminacion = 4;
  vtPermisoTodos = 5;
  vtPermisoExportar = 6;
  vtPermisoResolverIncidenciaTecnico = 7;
  vtPermisoReasignarIncidencia = 8;
  vtPermisoConfirmarIncidenciaUsuario = 9;
  vtPermisoReabrirIncidencia = 10;
  vtPermisoTareaIncidencia = 11;



  //para encriptacin de contraseas en AES
  claveEncriptacionTexto = '33eweEEr4$';


implementation


uses UnidadModuloDatos, UnidadPeticionUsuario, UnidadMenuprincipal,
  ZConnection, ZAbstractRODataset, UnidadGestionDocumental,
  UnidadEnvioEmail;

var
  compEnvioEmail : TIdSMTP;


function separarEmailLista (emails : string) : TStringList;
var
  lista : TStringList;
  posicionUltima, i : integer;
  emailTmp : string;
begin
  lista := TStringList.Create;
  posicionUltima := 0;
  if (pos(',', emails) > 0) or (pos(';', emails) > 0) then
  begin
    for i := posicionUltima to Length(emails) - 1 do
    begin
      emailTmp := '';
      repeat
        emailTmp := emailTmp + emails[posicionUltima];
        posicionUltima := posicionUltima + 1;
      until (emails[posicionUltima] = ';') or (emails[posicionUltima] = ',') or (posicionUltima = length(emails));
      lista.Add(emailTmp);
    end;
    if emailTmp <> '' then
      lista.Add (emailTmp); 
  end
  else
    lista.Add(emails);

  result := lista;
end;


procedure actualizarListaHistoricoTelefonos (codigo : integer);
begin
  md.tcTelefonoUsuarioLog.Close;
  md.tcTelefonoUsuarioLog.SQL.Clear;
  md.tcTelefonoUsuarioLog.SQL.Add('select t.*, m.nombre Marca');
  md.tcTelefonoUsuarioLog.SQL.Add('from ' + vtTablaTelefonoTerminalLog);
  md.tcTelefonoUsuarioLog.SQL.Add('  t left join  ' + vtTablaMarca + ' m on t.codigomarca = m.codigo');
  md.tcTelefonoUsuarioLog.SQL.Add('where t.codigotelefono = :pCodigo');
  md.tcTelefonoUsuarioLog.ParamByName('pCodigo').DataType := ftInteger;
  md.tcTelefonoUsuarioLog.ParamByName('pCodigo').AsInteger := codigo;
  md.tcTelefonoUsuarioLog.Open;
end;

{function cargarPerfilesTelefonos () : TStringList;
begin
  md.tc.Close;
  md.tc.SQL.Clear;
  md.tc.SQL.Add('select distinct(nombre) from ' + vtTablaTelefonoPerfil);
  try
    md.tc.Open;
    Result := TStringList.Create;
    while not md.tc.Eof do
    begin
      Result.Add (md.tc.FieldByName('nombre').AsString);
      md.tc.Next;
    end;
    md.tc.Close;
  except
    //silenciosa
  end;
end;}

procedure crearReferenciasIncidencias ();
var
  refIncidencia : string;
begin
  md.tc4.Close;
  md.tc4.SQL.Clear;
  md.tc4.SQL.Add('select codigo, fecha, tipo, referencia from incidencia');
  md.tc4.SQL.Add('order by fecha asc');
  md.tc4.Open;
  md.tIncidencia.Open;
  WHILE NOT md.tc4.Eof do
  begin
    refIncidencia := generarReferenciaIncidencia (md.tc4.fieldbyname('tipo').AsString, 'Incidencia',
        YearOf(md.tc4.fieldbyname('fecha').AsDateTime));

    if md.tIncidencia.locate ('Codigo', md.tc4.fieldbyname('codigo').AsInteger, []) then
    begin
      md.tIncidencia.edit;
      md.tIncidencia.FieldByName('referencia').AsString := refIncidencia;
      md.tIncidencia.Post;
    end
    else
    begin
      ShowMessage('No se ha encontrado la incidencia: ' + md.tc4.fieldbyname('codigo').AsString);
      exit;
    end;
    md.tc4.Next;
  end;
end;

function existenDocumentos (ventana : string; codigo : integer) : boolean;
begin
  Result := false;
  md.tc5.Close;
  md.tc5.SQL.Clear;
  md.tc5.SQL.Add('Select i.codigo');
  md.tc5.SQL.Add('from ' + vtTablaDocumento + ' i');
  md.tc5.SQL.Add('where i.ventana = :pNombre and i.codigoregistro = :pCodigo');
  md.tc5.ParamByName('pNombre').DataType := ftString;
  md.tc5.ParamByName('pNombre').AsString := ventana;
  md.tc5.ParamByName('pCodigo').DataType := ftInteger;
  md.tc5.ParamByName('pCodigo').AsInteger := codigo;
  try
    md.tc5.Open;
    Result := md.tc5.RecordCount > 0;
    md.tc5.Close;
  except
    //silenciosa
  end;
end;

function generarNumeroSerie (serie, tabla : string;
    anio : integer) : String;
var
  contador : integer;
begin
  result := '1';
  with md.tcContadorG do
  begin
    Close;
    //obtenemos el contador de
    //la tabla contadores
    SQL.Clear;
    SQL.Add('SELECT c.contador');
    SQL.Add('FROM ' + vtTablaContador + ' c');
    SQL.Add('WHERE c.tabla = :pTabla and c.serie = :pSerie and c.ano = :pAnio');
    ParamByName('pTabla').DataType := ftString;
    ParamByName('pTabla').AsString := tabla;
    ParamByName('pSerie').DataType := ftString;
    ParamByName('pSerie').AsString := serie;
    ParamByName('pAnio').DataType := ftInteger;
    ParamByName('pAnio').AsInteger := anio;
    Open;
    if RecordCount > 0 then
    begin
      try
        contador := FieldByName('contador').AsInteger + 1;

        //Incrementamos el contador de la tabla contadores
        Close;
        SQL.Clear;
        SQL.Add('UPDATE ' + vtTablaContador +
            ' SET contador = :pContador' +
            ' WHERE tabla = :pTabla' +
            ' and serie = :pSerie' +
            ' and ano = :pAnio');
        ParamByName('pContador').DataType := ftInteger;
        ParamByName('pContador').AsInteger := contador;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').AsString := tabla;
        ParamByName('pSerie').DataType := ftString;
        ParamByName('pSerie').AsString := serie;
        ParamByName('pAnio').DataType := ftInteger;
        ParamByName('pAnio').AsInteger := anio;
        ExecSQL;
        close;
        result := IntToStr (contador);
      except
        Close;
        result := '1';
        MessageDlg ('El cdigo no ha podido ' +
            'generarse automticamente.',
            mtError, [mbOK], 0);
      end;
    end
    else
    //si no existe el registro de
    //contador para la tabla actual, lo creamos
    begin
      try
        Close;
        SQL.Clear;
        SQL.Add('INSERT INTO ' + vtTablaContador +
            ' (tabla, serie, contador, anio) ' +
            ' VALUES (:pTabla, :pSerie, 1, :anio)');
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').AsString := tabla;
        ParamByName('pSerie').DataType := ftString;
        ParamByName('pSerie').AsString := serie;
        ParamByName('pAnio').DataType := ftInteger;
        ParamByName('pAnio').AsInteger := anio;
        ExecSQL;
        result := '1';
        Close;
      except
        Close;
        MessageDlg ('Ha habido un error al guardar el contador.',
            mtError, [mbOK], 0);
      end;
    end;
  end;
end;

function obtenerSerieIncidencia (tipo : string) : string;
begin
  Result := '';
  md.tc6.Close;
  md.tc6.SQL.Clear;
  md.tc6.SQL.Add('Select i.serie');
  md.tc6.SQL.Add('from ' + vtTablaIncidenciaTipo + ' i');
  md.tc6.SQL.Add('where i.nombre = :pNombre');
  md.tc6.ParamByName('pNombre').DataType := ftString;
  md.tc6.ParamByName('pNombre').AsString := tipo;
  md.tc6.Open;
  if md.tc6.RecordCount > 0 then
    Result := md.tc6.fieldbyname('serie').AsString
  else
    Result := '';
  md.tc6.Close;
end;


function generarReferenciaIncidencia (tipoSolicitud, tabla : string;
    anio : integer) : String;
var
  contador, contadorSiguiente : integer;
  serieTipo, anioDosDigitos, letra, contadorTexto : string;
  referenciaOb, letraSiguiente : string;
begin
  result := '';
  //obtenemos la serie asignada al tipo de solicitud
  serieTipo := obtenerSerieIncidencia(tipoSolicitud);
  if serieTipo = '' then
    serieTipo := 'Z';
  anioDosDigitos := RightStr (IntToStr(anio), 2);
  
  with md.tcContadorG do
  begin
    Close;
    //obtenemos el contador y letra actuales de la tabla contadores
    SQL.Clear;
    SQL.Add('SELECT c.contador, c.letra');
    SQL.Add('FROM ' + vtTablaContador + ' c');
    SQL.Add('WHERE c.tabla = :pTabla and c.serie = :pSerie and c.ano = :pAnio');
    ParamByName('pTabla').DataType := ftString;
    ParamByName('pTabla').AsString := tabla;
    ParamByName('pSerie').DataType := ftString;
    ParamByName('pSerie').AsString := serieTipo;
    ParamByName('pAnio').DataType := ftInteger;
    ParamByName('pAnio').AsInteger := anio;
    Open;
    //si ya hay contador con la serie, tabla y ao
    if RecordCount > 0 then
    begin
      try
        contador := FieldByName('contador').AsInteger;
        letra := FieldByName('letra').asString;
        if letra = '' then
          letra := 'A';

        { TODO : Permitir personalizar por configuracin el tamao de la
           referencia para que no haya lmite de Z999 }
        
        //si se ha llegado al final del contador de la letra
        if contador = 1000 then
        begin
          if letra = 'Z' then
          begin
            MessageDlg('Ha llegado al final de las posibilidades de ' +
                'la serializacin. Consulte con el desarrollador ' +
                'del software.', mtWarning, [mbok], 0);
            Result := '';
            exit;
          end
          else
          begin
            //incrementamos la letra
            letraSiguiente := chr(ord(letra[1]) + 1);
            contadorSiguiente := 1;
          end;
        end
        else
        begin
          letraSiguiente := letra;
          contadorSiguiente := contador + 1;
        end;

        contadorTexto := llenarCadena(IntToStr(contadorSiguiente), 3, '0', false);
        referenciaOb := serieTipo + letraSiguiente + contadorTexto + '-' + anioDosDigitos;

        //Incrementamos el contador de la tabla contadores
        Close;
        SQL.Clear;
        SQL.Add('UPDATE ' + vtTablaContador +
            ' SET contador = :pContador, ' +
            ' letra = :pLetra' +
            ' WHERE tabla = :pTabla' +
            ' and serie = :pSerie' +
            ' and ano = :pAnio');
        ParamByName('pContador').DataType := ftInteger;
        ParamByName('pContador').AsInteger := contadorSiguiente;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').AsString := tabla;
        ParamByName('pSerie').DataType := ftString;
        ParamByName('pSerie').AsString := serieTipo;
        ParamByName('pAnio').DataType := ftInteger;
        ParamByName('pAnio').AsInteger := anio;
        ParamByName('pLetra').DataType := ftString;
        ParamByName('pLetra').AsString := letraSiguiente;
        ExecSQL;
        close;
      except
        Close;
        result := '';
        MessageDlg ('La referencia no ha podido generarse automticamente.',
            mtError, [mbOK], 0);
      end;
    end
    else
    //si no existe el registro de
    //contador para la tabla actual, lo creamos
    begin
      try
        Close;
        SQL.Clear;
        SQL.Add('INSERT INTO ' + vtTablaContador +
            ' (tabla, serie, contador, ano, letra) ' +
            ' VALUES (:pTabla, :pSerie, 1, :pAnio, :pLetra)');
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').AsString := tabla;
        ParamByName('pSerie').DataType := ftString;
        ParamByName('pSerie').AsString := serieTipo;
        ParamByName('pAnio').DataType := ftInteger;
        ParamByName('pAnio').AsInteger := anio;
        ParamByName('pLetra').DataType := ftString;
        ParamByName('pLetra').AsString := 'A';
        ExecSQL;
        contadorTexto := llenarCadena('1', 3, '0', false);
        referenciaOb := serieTipo + 'A' + contadorTexto + '-' + anioDosDigitos;
        Close;
      except
        Close;
        MessageDlg ('Ha habido un error al guardar el contador.',
            mtError, [mbOK], 0);
      end;
    end;
  end;
  Result := referenciaOb;
end;

procedure quitarUsuarioDepartamento (codigoUsuario : integer;
    codigoDepartamento : integer);
begin
  md.tc6.Close;
  md.tc6.SQL.Clear;
  md.tc6.SQL.Add('delete from ' + vtTablaDepartamentoUsuarios);
  md.tc6.SQL.Add('where codigodepartamento = :pCodigoDepartamento and ');
  md.tc6.SQL.Add('codigousuario = :pCodigoUsuario');
  md.tc6.ParamByName('pCodigoDepartamento').DataType := ftInteger;
  md.tc6.ParamByName('pCodigoDepartamento').AsInteger := codigoDepartamento;
  md.tc6.ParamByName('pCodigoUsuario').DataType := ftInteger;
  md.tc6.ParamByName('pCodigoUsuario').AsInteger := codigoUsuario;
  try
    md.tc6.ExecSQL;
    md.tc6.close;
  except
    raise;
  end;
end;

procedure insertarUsuarioDepartamento (codigoUsuario : integer;
    codigoDepartamento : integer);
begin
  md.tc6.Close;
  md.tc6.SQL.Clear;
  md.tc6.SQL.Add('insert into ' + vtTablaDepartamentoUsuarios);
  md.tc6.SQL.Add('(codigodepartamento, codigousuario) values ');
  md.tc6.SQL.Add('(:pCodigoDepartamento, :pCodigoUsuario)');
  md.tc6.ParamByName('pCodigoDepartamento').DataType := ftInteger;
  md.tc6.ParamByName('pCodigoDepartamento').AsInteger := codigoDepartamento;
  md.tc6.ParamByName('pCodigoUsuario').DataType := ftInteger;
  md.tc6.ParamByName('pCodigoUsuario').AsInteger := codigoUsuario;
  try
    md.tc6.ExecSQL;
    md.tc6.close;
  except
    raise;
  end;
end;


function anosMesesDias(fechaInicio : TDate;
    fechaFin : TDate) : string;
var
  anos, meses, dias, m : Integer;
begin
  anos := YearOf (fechaFin) - YearOf (fechaInicio);
  if MonthOf (fechaInicio) > MonthOf (fechaFin) then
    anos := anos - 1;
  if MonthOf (fechaFin) < MonthOf (fechaInicio) then
    meses := 12 - MonthOf (fechaInicio) + MonthOf (fechaFin)
  else
    meses := MonthOf (fechaFin) - MonthOf (fechaInicio);
  if DayOf (fechaFin) < DayOf (fechaInicio) then
  begin
    meses := meses - 1;
    if MonthOf (fechaFin) = MonthOf (fechaInicio) then
    begin
      anos := anos - 1;
      meses := 11;
    end;
  end;
  dias := DayOf (fechaFin) - DayOf (fechaInicio);
  if dias < 0 then
  begin
    m := MonthOf (fechaFin) - 1;
    if m = 0 then
      m := 12;
    case m of
      1, 3, 5, 7, 8, 10, 12 : dias := 31 + dias;
      4, 6, 9, 11 : dias := 30 + dias;
      2 :
      begin
        if ((YearOf(fechaFin) mod 4 = 0) and
            (YearOf(fechaFin) mod 100 <> 0))
            or (YearOf(fechaFin) mod 400 = 0) then
          dias := 29 + dias
        else
          dias := 28 + dias;
      end;
    end;
  end;
  result := IntToStr (anos) + ' aos, ' +
      IntToStr (meses) + ' meses, ' +
      IntToStr (dias) + ' das';
end;

function obtenerDepartamentoUsuario (codigoUsuario : integer) : string;
begin
  Result := '';
  md.tc6.Close;
  md.tc6.SQL.Clear;
  md.tc6.SQL.Add('Select d.nombre Departamento');
  md.tc6.SQL.Add('from ' + vtTablaUsuario + ' u, ' + vtTablaDepartamento + ' d');
  md.tc6.SQL.Add('where u.codigo=:pCodigo and u.codigodepartamento=d.codigo');
  md.tc6.ParamByName('pCodigo').DataType := ftInteger;
  md.tc6.ParamByName('pCodigo').AsInteger := codigoUsuario;
  md.tc6.Open;
  if md.tc6.RecordCount > 0 then
    Result := md.tc6.fieldbyname('departamento').AsString
  else
    Result := '';
  md.tc6.Close;
end;


function obtenerCodigoMotivoResolucion (nombreMotivo : String) : integer;
begin
  md.tc6.Close;
  md.tc6.SQL.Clear;
  md.tc6.SQL.Add('Select i.codigo');
  md.tc6.SQL.Add('from ' + vtTablaIncidenciaResolucion + ' i');
  md.tc6.SQL.Add('where i.nombre = :pMotivo');
  md.tc6.ParamByName('pMotivo').DataType := ftString;
  md.tc6.ParamByName('pMotivo').AsString := nombreMotivo;
  md.tc6.Open;
  if md.tc6.RecordCount > 0 then
    Result := md.tc6.fieldbyname('codigo').AsInteger
  else
    Result := 0;
  md.tc6.Close;
end;


function obtenerSubcategoriaIncidencia (codigoIncidencia : integer) : integer;
begin
  md.tc6.Close;
  md.tc6.SQL.Clear;
  md.tc6.SQL.Add('Select i.codigosubcategoria');
  md.tc6.SQL.Add('from ' + vtTablaIncidencia + ' i');
  md.tc6.SQL.Add('where i.codigo=:pCodigo');
  md.tc6.ParamByName('pCodigo').DataType := ftInteger;
  md.tc6.ParamByName('pCodigo').AsInteger := codigoIncidencia;
  md.tc6.Open;
  if md.tc6.RecordCount > 0 then
    Result := md.tc6.fieldbyname('codigosubcategoria').AsInteger
  else
    Result := 0;
  md.tc6.Close;
end;

procedure actualizarTiempoMedioSubcategoria (codigoIncidencia : integer);
var
  tiempoMedio, codigoSubcategoria : integer;
begin
  tiempoMedio := obtenerTiempoMedioResolucionIncidencia (codigoIncidencia);
  codigoSubcategoria := obtenerSubcategoriaIncidencia(codigoIncidencia);
  if (tiempoMedio <> 0) and (codigoSubcategoria <> 0) then
  begin
    md.tc6.Close;
    md.tc6.SQL.Clear;
    md.tc6.SQL.Add('update ' + vttablaSubCategoria);
    md.tc6.SQL.Add('set tiempomedio=:pTiempo');
    md.tc6.SQL.Add('where codigo=:pCodigo');
    md.tc6.ParamByName('pCodigo').DataType := ftInteger;
    md.tc6.ParamByName('pCodigo').AsInteger := codigoSubcategoria;
    md.tc6.ParamByName('pTiempo').DataType := ftInteger;
    md.tc6.ParamByName('pTiempo').AsInteger := tiempoMedio;
    md.tc6.ExecSQL;
    md.tc6.Close;
  end;
end;

procedure actualizarRecursoSiAutomatico (codigoUsuario : integer);
var
  codigoRecurso : integer;
begin
  md.tc6.Close;
  md.tc6.SQL.Clear;
  md.tc6.SQL.Add('select count(*) NumeroIncidencias, codigorecurso');
  md.tc6.SQL.Add('from ' + vtTablaIncidencia);
  md.tc6.SQL.Add('where codigousuario = :pCodigo');
  md.tc6.SQL.Add('group by codigorecurso');
  md.tc6.SQL.Add('order by NumeroIncidencias desc');
  md.tc6.ParamByName('pCodigo').DataType := ftInteger;
  md.tc6.ParamByName('pCodigo').AsInteger := codigoUsuario;
  md.tc6.open;
  if md.tc6.RecordCount > 0 then
  begin
    codigoRecurso := md.tc6.fieldbyname('codigorecurso').AsInteger;
    md.tc6.Close;
    md.tc6.SQL.Clear;
    md.tc6.SQL.Add('update ' + vtTablaUsuario);
    md.tc6.SQL.Add('set codigorecurso = :pCodigoRecurso');
    md.tc6.SQL.Add('where codigo = :pCodigo and recursoauto = "S"');
    md.tc6.ParamByName('pCodigoRecurso').DataType := ftInteger;
    md.tc6.ParamByName('pCodigoRecurso').AsInteger := codigoRecurso;
    md.tc6.ParamByName('pCodigo').DataType := ftInteger;
    md.tc6.ParamByName('pCodigo').AsInteger := codigoUsuario;
    md.tc6.ExecSQL;
  end;
  md.tc6.Close;
end;


function obtenerRecursoUsuario (codigoUsuario : integer) : integer;
begin
  md.tc6.Close;
  md.tc6.SQL.Clear;
  md.tc6.SQL.Add('select codigorecurso');
  md.tc6.SQL.Add('from ' + vtTablaUsuario);
  md.tc6.SQL.Add('where codigo = :pCodigo');
  md.tc6.ParamByName('pCodigo').DataType := ftInteger;
  md.tc6.ParamByName('pCodigo').AsInteger := codigoUsuario;
  md.tc6.Open;
  if md.tc6.RecordCount > 0 then
    Result := md.tc6.fieldbyname ('codigorecurso').asInteger
  else
    Result := -1;
  md.tc6.Close;
end;


function listaCategoriasSubcategorias (categoriasPrincipio : boolean;
    categoriasSubcategorias : Boolean) : TStringList;
var
  lista : TStringList;
begin
  lista := TStringList.Create;
  if categoriasPrincipio then
  begin
    md.tc5.Close;
    md.tc5.SQL.Clear;
    md.tc5.SQL.Add('Select c.nombre Categoria');
    md.tc5.SQL.Add('from ' + vttablaCategoria + ' c');
    md.tc5.SQL.Add('order by c.nombre');
    md.tc5.Open;
    while not md.tc5.Eof do
    begin
      lista.Add(md.tc5.fieldbyname('categoria').AsString);
      md.tc5.Next;
    end;
    md.tc5.Close;
  end;
  if categoriasSubcategorias then
  begin
    md.tc5.Close;
    md.tc5.SQL.Clear;
    md.tc5.SQL.Add('Select c.nombre Categoria, s.nombre Subcategoria');
    md.tc5.SQL.Add('from ' + vttablaCategoria + ' c, ' + vttablaSubCategoria + ' s');
    md.tc5.SQL.Add('where c.codigo = s.codigocategoria');
    md.tc5.SQL.Add('order by c.nombre, s.nombre');
    md.tc5.Open;
    while not md.tc5.Eof do
    begin
      lista.Add(md.tc5.fieldbyname('categoria').AsString + ' - ' +
          md.tc5.fieldbyname('subcategoria').AsString);
      md.tc5.Next;
    end;
    md.tc5.Close;    
  end;
  Result := lista;
end;

function listaMotivosResolucion (incidencia : integer) : TStringList;
var
  lista : TStringList;
begin
  lista := TStringList.Create;
  md.tc5.Close;
  md.tc5.SQL.Clear;
  md.tc5.SQL.Add('Select c.nombre Motivo');
  md.tc5.SQL.Add('from ' + vtTablaIncidencia + ' i, '  + vtTablaIncidenciaResolucion + ' c');
  md.tc5.SQL.Add('where i.codigosubcategoria = c.codigosubcategoria and i.codigo = :pCodigo');
  md.tc5.SQL.Add('order by c.nombre');
  md.tc5.ParamByName ('pCodigo').DataType := ftInteger;
  md.tc5.ParamByName ('pCodigo').AsInteger := incidencia;
  md.tc5.Open;
  while not md.tc5.Eof do
  begin
    lista.Add(md.tc5.fieldbyname('Motivo').AsString);
    md.tc5.Next;
  end;
  Result := lista;
  md.tc5.Close;
end;


function obtenerTiempoMedioResolucionIncidencia (codigoIncidencia : integer) : integer;
begin
  md.tc4.Close;
  md.tc4.Connection := md.bd;
  md.tc4.SQL.Clear;
  md.tc4.SQL.Add ('select truncate(avg(tiempoempleado), 0) tiempo_medio');
  md.tc4.SQL.Add ('from ' + vtTablaIncidencia + ' i');
  md.tc4.SQL.Add ('where i.codigosubcategoria in (');
  md.tc4.SQL.Add ('  select u.codigosubcategoria');
  md.tc4.SQL.Add ('  from ' + vtTablaIncidencia + ' u');
  md.tc4.SQL.Add ('  where u.codigo=:pCodigo)');
  md.tc4.ParamByName('pCodigo').DataType := ftInteger;
  md.tc4.ParamByName('pCodigo').AsInteger := codigoIncidencia;
  md.tc4.open;
  if md.tc4.fieldbyname('tiempo_medio').IsNull then
    Result := 0
  else
    Result := trunc (md.tc4.fieldbyname('tiempo_medio').AsInteger);
  md.tc4.Close;
end;


function obtenerUsuarioIncidencia (codigoIncidencia : integer) : integer;
begin
  md.tc4.Close;
  md.tc4.Connection := md.bd;
  md.tc4.SQL.Clear;
  md.tc4.SQL.Add('select i.codigousuario');
  md.tc4.SQL.Add ('from ' + vtTablaIncidencia + ' i');
  md.tc4.SQL.Add ('where i.codigo = :pCodigo');
  md.tc4.ParamByName('pCodigo').DataType := ftInteger;
  md.tc4.ParamByName('pCodigo').AsInteger := codigoIncidencia;
  md.tc4.open;
  if md.tc4.RecordCount > 0 then
    Result := md.tc4.fieldbyname('codigousuario').AsInteger
  else
    Result := -1;
  md.tc4.Close;
end;

procedure incidenciaAvisada (codigoIncidencia : integer);
begin
  with md.tcNotificacion do
  begin
    Close;
    SQL.Clear;
    SQL.Add('UPDATE ' + vtTablaIncidencia + ' SET ');
    SQL.Add('  aviso = :pAviso');
    SQL.Add('  where codigo = :pCodigo');
    ParamByName('pCodigo').DataType := ftInteger;
    ParamByName('pCodigo').AsInteger := codigoIncidencia;
    ParamByName('pAviso').DataType := ftInteger;
    ParamByName('pAviso').AsString := 'S';
    try
      ExecSQL;
      Close;
    except
      //---------silenciosa-----------
      close;
    end;
  end;
end;

function unSoloTecnicoDepartamento (codigoDepartamento : integer) : integer;
begin
  with md.tc6 do
  begin
    Close;
    SQL.Clear;
    SQL.Add('SELECT du.codigousuario');
    SQL.Add('FROM ' + vtTablaDepartamentoUsuarios + ' du');
    SQL.Add('WHERE codigodepartamento = :pCodigo');
    ParamByName('pCodigo').DataType := ftInteger;
    ParamByName('pCodigo').AsInteger := codigoDepartamento;
    try
      Open;
      if RecordCount = 1 then
        Result := fieldbyname('codigousuario').AsInteger
      else
        Result := -1;
    except
      Result := -1;
      //---------silenciosa-----------
      close;
    end;
  end;
end;

procedure incidenciaCambiarTecnicoAsignado (codigoIncidencia : integer;
    codigoTecnico : integer; codigoDepartamento : integer; aceptada : boolean);
begin
  with md.tc3 do
  begin
    Close;
    SQL.Clear;
    SQL.Add('UPDATE ' + vtTablaIncidencia + ' SET ');
    SQL.Add('  codigotecnico = :pCodigoTecnico, codigodepartamento = :pCodigoDepartamento,');
    SQL.Add('  aceptada = :pAceptada,');
    SQL.Add('  estado = :pEstado');
    SQL.Add('  where codigo = :pCodigo');
    ParamByName('pCodigo').DataType := ftInteger;
    ParamByName('pCodigo').AsInteger := codigoIncidencia;
    ParamByName('pCodigoTecnico').DataType := ftInteger;
    ParamByName('pCodigoTecnico').AsInteger := codigoTecnico;
    ParamByName('pCodigoDepartamento').DataType := ftInteger;
    ParamByName('pCodigoDepartamento').AsInteger := codigoDepartamento;
    ParamByName('pEstado').DataType := ftString;
    if not aceptada then
      ParamByName('pEstado').AsString := 'Pendiente valoracin'
    else
      ParamByName('pEstado').AsString := 'En curso';
    ParamByName('pAceptada').DataType := ftString;
    if aceptada then
      ParamByName('pAceptada').AsString := 'S'
    else
      ParamByName('pAceptada').AsString := 'N';
    try
      ExecSQL;
      Close;
    except
      //---------silenciosa-----------
      close;
    end;
  end;
end;

procedure horasMinutosSegundos (numSegundos : integer; var horas,
    minutos, segundos : integer);
begin
  horas := numSegundos div 3600;
  minutos := numSegundos div 60 mod 60;
  segundos := numSegundos mod 60;
end;


//obtener categora y subcategora de los recursos para las incidencias
procedure obtenerCategoriaSubcategoriaRecurso (codigoRecurso : integer;
    var codigoCategoria : integer; var codigoSubcategoria : integer);
begin
  codigoCategoria := -1;
  codigoSubcategoria := -1;
  md.tc4.Close;
  md.tc4.Connection := md.bd;
  md.tc4.SQL.Clear;
  md.tc4.SQL.Add('select r.codigocategoria, r.codigosubcategoria');
  md.tc4.SQL.Add ('from ' + vtTablaRecurso + ' r');
  md.tc4.SQL.Add ('where r.codigo = :pCodigo');
  md.tc4.ParamByName('pCodigo').DataType := ftInteger;
  md.tc4.ParamByName('pCodigo').AsInteger := codigoRecurso;
  md.tc4.open;
  if md.tc4.RecordCount > 0 then
  begin
    if not VarIsNull(md.tc4.fieldbyname('codigocategoria').Value) then
      codigoCategoria := md.tc4.fieldbyname('codigocategoria').AsInteger;
    if not VarIsNull(md.tc4.fieldbyname('codigosubcategoria').Value) then
      codigoSubcategoria := md.tc4.fieldbyname('codigosubcategoria').AsInteger;
  end;
  md.tc4.Close;
end;

function usuarioPerteneceDepartamento (codigoUsuario : integer;
    codigoDepartamento : integer) : boolean;
begin
  md.tc4.Close;
  md.tc4.Connection := md.bd;
  md.tc4.SQL.Clear;
  md.tc4.SQL.Add ('select u.codigo');
  md.tc4.SQL.Add ('from ' + vtTablaUsuario + ' u');
  md.tc4.SQL.Add ('where u.codigo = :pCodigo');
  md.tc4.SQL.Add ('  and (u.codigodepartamento = :pCodigoDepartamento or u.codigo IN (');
  md.tc4.SQL.Add ('    select d.codigousuario');
  md.tc4.SQL.Add ('    from ' + vtTablaDepartamentoUsuarios + ' d');
  md.tc4.SQL.Add ('    where d.codigodepartamento = :pCodigoDepartamento and d.codigousuario = :pCodigo))');
  md.tc4.ParamByName('pCodigo').DataType := ftInteger;
  md.tc4.ParamByName('pCodigo').AsInteger := codigoUsuario;
  md.tc4.ParamByName('pCodigoDepartamento').DataType := ftInteger;
  md.tc4.ParamByName('pCodigoDepartamento').AsInteger := codigoDepartamento;
  md.tc4.open;
  Result := md.tc4.RecordCount > 0;
  md.tc4.Close;
end;

function subcategoriaPerteneceCategoria (codigoSubcategoria : integer;
    codigoCategoria : integer) : boolean;
begin
  md.tc4.Close;
  md.tc4.Connection := md.bd;
  md.tc4.SQL.Clear;
  md.tc4.SQL.Add('select s.codigocategoria');
  md.tc4.SQL.Add ('from ' + vttablaSubCategoria + ' s');
  md.tc4.SQL.Add ('where s.codigo = :pCodigo');
  md.tc4.ParamByName('pCodigo').DataType := ftInteger;
  md.tc4.ParamByName('pCodigo').AsInteger := codigoSubcategoria;
  md.tc4.open;
  if md.tc4.RecordCount > 0 then
    Result := md.tc4.fieldbyname('codigocategoria').AsInteger = codigoCategoria
  else
    Result := false;
  md.tc4.Close;
end;

function usuarioEsTecnico (codigo : integer) : boolean;
begin
  Result := false;
  md.tc4.Close;
  md.tc4.Connection := md.bd;
  md.tc4.SQL.Clear;
  md.tc4.SQL.Add('select u.tipo, u.codigodepartamento');
  md.tc4.SQL.Add ('from ' + vtTablaUsuario + ' u');
  md.tc4.SQL.Add ('where u.codigo = :pCodigo');
  md.tc4.ParamByName('pCodigo').DataType := ftInteger;
  md.tc4.ParamByName('pCodigo').AsInteger := codigo;
  md.tc4.open;
  if md.tc4.RecordCount > 0 then
    Result := md.tc4.fieldbyname('tipo').AsString = 'Tcnico';
  md.tc4.Close;
end;

function departamentoEsTecnico (codigo : integer) : boolean;
begin
  Result := false;
  md.tc4.Close;
  md.tc4.Connection := md.bd;
  md.tc4.SQL.Clear;
  md.tc4.SQL.Add('select d.tecnico');
  md.tc4.SQL.Add ('from ' + vtTablaDepartamento + ' d');
  md.tc4.SQL.Add ('where d.codigo = :pCodigo');
  md.tc4.ParamByName('pCodigo').DataType := ftInteger;
  md.tc4.ParamByName('pCodigo').AsInteger := codigo;
  md.tc4.open;
  if md.tc4.RecordCount > 0 then
    Result := md.tc4.fieldbyname('tecnico').AsString = 'S';
  md.tc4.Close;
end;

//cambia el estado de la incidencia indicada
procedure incidenciaCambiarEstado (codigoIncidencia : integer; estado : string);
begin
  with md.tc3 do
  begin
    Close;
    SQL.Clear;
    SQL.Add('UPDATE ' + vtTablaIncidencia + ' SET ');
    SQL.Add('  estado = :pestado');
    SQL.Add('  where codigo = :pCodigo');
    ParamByName('pCodigo').DataType := ftInteger;
    ParamByName('pCodigo').AsInteger := codigoIncidencia;
    ParamByName('pestado').DataType := ftString;
    ParamByName('pestado').AsString := estado;
    try
      ExecSQL;
      Close;
    except
      //---------silenciosa-----------
      close;
    end;
  end;
end;


//Obtiene el valor de la tabla usuario: mostrarsolosusincidencias
//devuelve True si el usuario slo puede ver sus incidencias
function usuarioMostrarSusIncidencias (codigo : integer) : boolean;
begin
  result := true;
  md.tc3.Close;
  md.tc3.SQL.Clear;
  md.tc3.SQL.Add('select mostrarsolosusincidencias');
  md.tc3.SQL.Add('from ' + vtTablaUsuario + ' u');
  md.tc3.SQL.Add('where u.codigo = :pCodigo');
  md.tc3.ParamByName('pCodigo').DataType := ftInteger;
  md.tc3.ParamByName('pCodigo').AsInteger := codigo;
  try
    md.tc3.Open;
    if md.tc3.RecordCount > 0 then
      result := md.tc3.FieldByName('mostrarsolosusincidencias').AsString = 'S'
    else
      Result := true;
    md.tc3.Close;
  except
    md.tc3.Close;
    //silenciosa
  end;
end;



//devolver el usuario al que le asigne la incidencia
//de forma automtica segn varios criterios
//Devuelve:
//-2: la incidencia no existe o ya est resuelta
//-1: no hay tcnicos disponibles para el dpto. de la incidencia
function asignarIncidenciaAuto (codigoIncidencia : integer;
    codigoUsuarioExcluir : integer; codigoSubcategoria : integer) : integer;
var
  departamentoIncidencia : integer;
begin
   //criterio 2: en parmetros, por ubicacin del usuario que la da de alta, al tcnico de esa ubicacin
   //criterio 3: la suma del tiempo de resolucin de las incidencias activas sea menor
   //criterio 4: si no se cumple ninguna de las anteriores: asignar a tcnico definido en parmetros para tal efecto

  //si no se especifica la subcategora la obtenemos a partir del
  //cdigo de incidencia
  if (codigoSubcategoria <= 0) then
  begin
    md.tc3.Close;
    md.tc3.SQL.Clear;
    md.tc3.Connection := md.bd;
    md.tc3.SQL.Add('select i.codigo, i.codigosubcategoria');
    md.tc3.SQL.Add('from ' + vtTablaIncidencia + ' i');
    md.tc3.SQL.Add('where i.codigo = :pCodigo and i.resueltatecnico = "N"');
    md.tc3.ParamByName ('pCodigo').DataType := ftInteger;
    md.tc3.ParamByName ('pCodigo').AsInteger := codigoIncidencia;
    md.tc3.open;
    if md.tc3.RecordCount > 0 then
      codigoSubcategoria := md.tc3.fieldbyname('codigosubcategoria').AsInteger
    else
    begin
      Result := -1;
      md.tc3.Close;
      Exit;
    end;
  end;

  departamentoIncidencia := obtenerDepartamentoTecnicoSubcategoria (codigoSubcategoria);

  //si un tcnico no tiene incidencias asignadas y no est de vacaciones
  //se le asignar directamente a ste
  //esta diferenciacin se hace porque la consulta siguiente no funciona
  //cuando el tcnico no tiene incidencias asignadas
  md.tc3.Close;
  md.tc3.SQL.Clear;
  md.tc3.Connection := md.bd;
  md.tc3.SQL.Add('select u.codigo Codigo_Tecnico');
  md.tc3.SQL.Add('from ' + vtTablaUsuario + ' u');
  md.tc3.SQL.Add('where u.vacaciones <> "S" and u.activo = "S" and u.codigo');
  md.tc3.SQL.Add('and u.codigo in (');
  md.tc3.SQL.Add('  select d.codigousuario');
  md.tc3.SQL.Add('  from ' + vtTablaDepartamentoUsuarios + ' d');
  md.tc3.SQL.Add('  where d.codigodepartamento = :pCodDep)');
  md.tc3.SQL.Add('  and  u.codigo not IN (');
  md.tc3.SQL.Add('  select i.codigotecnico');
  md.tc3.SQL.Add('  from ' + vtTablaIncidencia + ' i');
  md.tc3.SQL.Add('  where i.resueltatecnico = "N" or i.resueltatecnico is null)');
  md.tc3.ParamByName('pCodDep').DataType := ftInteger;
  md.tc3.ParamByName('pCodDep').AsInteger := departamentoIncidencia;
  md.tc3.Open;
  if md.tc3.RecordCount > 0 then
  begin
    Result := md.tc3.fieldbyname('Codigo_Tecnico').AsInteger;
  end
  else
  begin
    //obtener el tiempo total de los tcnicos del departamento de la subcategora
    //de la incidencia, el primer registro ser el tcnico con menos tiempo
    md.tc3.Close;
    md.tc3.SQL.Clear;
    md.tc3.Connection := md.bd;
    md.tc3.SQL.Add('select ii.codigotecnico Codigo_Tecnico, count(*) Numero_Total,');
    md.tc3.SQL.Add('    sum((select avg(i.tiempoempleado)');
    md.tc3.SQL.Add('    from ' + vtTablaIncidencia + ' i');
    md.tc3.SQL.Add('    where i.tiempoempleado is not null and i.tiempoempleado <> 0');
    md.tc3.SQL.Add('      and i.codigosubcategoria = ii.codigosubcategoria and');
    md.tc3.SQL.Add('     (i.estado = "Resuelto" or i.estado = "Resuelto pendiente confirmacin")');
    md.tc3.SQL.Add('    group by i.codigosubcategoria)) as Tiempo_Total');
    md.tc3.SQL.Add('from ' + vtTablaIncidencia + ' ii, ' + vtTablaUsuario + ' uu, ' + vttablaSubCategoria + ' ss');
    md.tc3.SQL.Add('where ii.codigotecnico = uu.codigo and ii.resueltatecnico = "N"');
    if codigoUsuarioExcluir > 0 then
      md.tc3.SQL.Add('and ii.codigotecnico <> :pCodigoUsuarioExcluir');
    md.tc3.SQL.Add('  and uu.activo = "S"');
    md.tc3.SQL.Add('  and ss.codigo = ii.codigosubcategoria');
    md.tc3.SQL.Add('  and (uu.codigodepartamento=:pCodigoDepartamento OR uu.codigo IN');
    md.tc3.SQL.Add('    (select d.codigousuario');
    md.tc3.SQL.Add('     from departamentousuarios d');
    md.tc3.SQL.Add('     where d.codigousuario = uu.codigo');
    md.tc3.SQL.Add('         and d.codigodepartamento=:pCodigoDepartamento))');

    //    md.tc3.SQL.Add('         and d.codigodepartamento = ss.codigodepartamento and d.codigodepartamento=:pCodigoDepartamento))');

    md.tc3.SQL.Add('group by ii.codigotecnico');
    md.tc3.SQL.Add('order by Tiempo_Total asc, Numero_Total asc');
    md.tc3.ParamByName('pCodigoDepartamento').DataType := ftInteger;
    md.tc3.ParamByName('pCodigoDepartamento').AsInteger := departamentoIncidencia;
    if codigoUsuarioExcluir > 0 then
    begin
      md.tc3.ParamByName('pCodigoUsuarioExcluir').DataType := ftInteger;
      md.tc3.ParamByName('pCodigoUsuarioExcluir').AsInteger := codigoUsuarioExcluir;
    end;
    md.tc3.Open;
    if md.tc3.RecordCount > 0 then
    begin
      md.tc3.First;
      Result := md.tc3.fieldbyname('Codigo_Tecnico').AsInteger;
    end
    else
      Result := -1; //no hay tcnicos disponibles
  end;

  md.tc3.Close;
end;


function extraerNickUsuario (codigo : integer) : string;
begin
  result := '';
  md.tc3.Close;
  md.tc3.Connection := md.bd;
  md.tc3.SQL.Clear;
  md.tc3.SQL.Add('select nick');
  md.tc3.SQL.Add ('from ' + vtTablaUsuario);
  md.tc3.SQL.Add ('where codigo = :pCodigo');
  md.tc3.ParamByName('pcodigo').DataType := ftInteger;
  md.tc3.ParamByName('pcodigo').AsInteger := codigo;
  try
    md.tc3.open;
    if md.tc3.RecordCount > 0 then
      Result := md.tc3.fieldbyname('nick').AsString
    else
      Result := '';
    md.tc3.Close;
  except
    //silenciosa
    md.tc3.Close;
  end;
end;

function obtenerPrioridadSubcategoria (codigoSubcategoria : integer) : integer;
begin
  Result := 1;
  md.tc3.Close;
  md.tc3.Connection := md.bd;
  md.tc3.SQL.Clear;
  md.tc3.SQL.Add('select prioridad');
  md.tc3.SQL.Add ('from ' + vttablaSubCategoria);
  md.tc3.SQL.Add ('where codigo = :pCodigo');
  md.tc3.ParamByName('pcodigo').DataType := ftInteger;
  md.tc3.ParamByName('pcodigo').AsInteger := codigoSubcategoria;
  md.tc3.open;
  if md.tc3.RecordCount > 0 then
    Result := md.tc3.fieldbyname('prioridad').AsInteger;
  md.tc3.Close;
end;

function tiempoTotalTareasIncidencia (codigoInciencia : integer) : integer;
begin
  Result := 0;
  md.tc3.Close;
  md.tc3.Connection := md.bd;
  md.tc3.SQL.Clear;
  md.tc3.SQL.Add('select sum(valornumerico) TiempoTotal');
  md.tc3.SQL.Add ('from ' + vtTablaIncidenciasLog);
  md.tc3.SQL.Add ('where codigoincidencia = :pCodigo and accion = :pAccion');
  md.tc3.ParamByName('pcodigo').DataType := ftInteger;
  md.tc3.ParamByName('pcodigo').AsInteger := codigoInciencia;
  md.tc3.ParamByName('pAccion').DataType := ftString;
  md.tc3.ParamByName('pAccion').AsString := 'Aadida tarea';
  try
    md.tc3.open;
    if md.tc3.fieldbyname('TiempoTotal').IsNull then
      Result := 0
    else
      Result := md.tc3.fieldbyname('TiempoTotal').AsInteger;
    md.tc3.Close;
  except
    //silenciosa
    md.tc3.close;
  end;
end;


function obtenerPrioridadUsuario (codigoUsuario : integer) : integer;
begin
  Result := 1;
  md.tc3.Close;
  md.tc3.Connection := md.bd;
  md.tc3.SQL.Clear;
  md.tc3.SQL.Add('select prioridad');
  md.tc3.SQL.Add ('from ' + vtTablaUsuario);
  md.tc3.SQL.Add ('where codigo = :pCodigo');
  md.tc3.ParamByName('pcodigo').DataType := ftInteger;
  md.tc3.ParamByName('pcodigo').AsInteger := codigoUsuario;
  md.tc3.open;
  if md.tc3.RecordCount > 0 then
    Result := md.tc3.fieldbyname('prioridad').AsInteger;
  md.tc3.Close;
end;

function establecerPrioridadIncidencia (codigoUsuario, codigoSubcategoria, codigoIncidencia : Integer) : integer;
var
  prioridadSubcategoria, prioridadUsuario : integer;
begin
  prioridadSubcategoria := obtenerPrioridadSubcategoria(codigoSubcategoria);
  prioridadUsuario := obtenerPrioridadUsuario(codigoUsuario);
   { TODO : Falta prioridad por tiempo de resolucin }

  Result := (prioridadSubcategoria + prioridadUsuario) div 2; 

end;

function incidenciaObtenerDepartamentoUsuario (codigoIncidencia : integer) : string;
begin
  Result := '';
  md.tc4.Close;
  md.tc4.Connection := md.bd;
  md.tc4.SQL.Clear;
  md.tc4.SQL.Add('select d.nombre departamento');
  md.tc4.SQL.Add ('from ' + vtTablaDepartamento + ' d, ' + vtTablaUsuario + ' u');
  md.tc4.SQL.Add ('where d.codigo = u.codigodepartamento and u.codigo in (');
  md.tc4.SQL.Add ('  select i.codigousuario');
  md.tc4.SQL.Add ('  from ' + vtTablaIncidencia + ' i');
  md.tc4.SQL.Add ('  where i.codigo = :pCodigo)');
  md.tc4.ParamByName('pCodigo').DataType := ftInteger;
  md.tc4.ParamByName('pCodigo').AsInteger := codigoIncidencia;
  md.tc4.open;
  if md.tc4.RecordCount > 0 then
    Result := md.tc4.fieldbyname('departamento').AsString;
  md.tc4.Close;
end;

function incidenciaObtenerCodigoDepartamentoUsuario (codigoIncidencia : integer) : integer;
begin
  Result := -1;
  md.tc4.Close;
  md.tc4.Connection := md.bd;
  md.tc4.SQL.Clear;
  md.tc4.SQL.Add('select u.codigodepartamento');
  md.tc4.SQL.Add ('from ' + vtTablaIncidencia + ' i, ' + vtTablaUsuario + ' u');
  md.tc4.SQL.Add ('where i.codigo = :pCodigo and u.codigo=i.codigousuario');
  md.tc4.ParamByName('pCodigo').DataType := ftInteger;
  md.tc4.ParamByName('pCodigo').AsInteger := codigoIncidencia;
  md.tc4.open;
  if md.tc4.RecordCount > 0 then
    Result := md.tc4.fieldbyname('codigodepartamento').AsInteger;
  md.tc4.Close;
end;

procedure enviarEmailEstadoIncidencia (codigoIncidencia : integer;
    tipo : string; mostrarFormulario : boolean; departamentoTecnico : boolean);
var
  mensajeTexto : TStringList;
  asunto, emailFormulario, nombreFormulario : string;
begin
  md.tc3.Close;
  md.tc3.Connection := md.bd;
  md.tc3.SQL.Clear;
  md.tc3.SQL.Add('select i.*, u.nick Tecnico, u.nombre Tecnico_nombre, uu.nombre Usuario, uu.nick nick_usuario,' +
      ' ca.nombre Categoria, su.nombre Subcategoria');
  md.tc3.SQL.Add ('from ' + vtTablaIncidencia + ' i, ' +
      vtTablaUsuario + ' u, ' + vtTablaUsuario + ' uu, ' +
      vttablaCategoria + ' ca, ' + vttablaSubcategoria + ' su');
  md.tc3.SQL.Add ('where i.codigotecnico = u.codigo and ');
  md.tc3.SQL.Add ('    i.codigousuario=uu.codigo and ');
  md.tc3.SQL.Add ('    i.codigotecnico = u.codigo and ');
  md.tc3.SQL.Add ('    i.codigocategoria=ca.codigo and ');
  md.tc3.SQL.Add ('    i.codigosubcategoria=su.codigo and');
  md.tc3.SQL.Add ('    i.codigo=:pCodigo');
  md.tc3.ParamByName('pcodigo').DataType := ftInteger;
  md.tc3.ParamByName('pcodigo').AsInteger := codigoIncidencia;
  md.tc3.open;
  if md.tc3.RecordCount > 0 then
  begin
    if md.tc3.fieldbyname('completado').AsInteger <> 100 then
      asunto := 'Tarea/Solicitud [' + md.tc3.fieldbyname('referencia').AsString + '] ' +
          md.tc3.fieldbyname('asunto').AsString
    else
      asunto := 'Tarea/Solicitud [' + md.tc3.fieldbyname('referencia').AsString + '] RESUELTA';
    mensajeTexto := TStringList.Create;
    mensajeTexto.Add ('Ref. Tarea/Solicitud: ' + md.tc3.fieldbyname('referencia').AsString);
    mensajeTexto.Add ('Fecha alta: ' + md.tc3.fieldbyname('fecha').AsString);
    mensajeTexto.Add ('Usuario: ' + md.tc3.fieldbyname('Usuario').AsString + ' (' +
        md.tc3.fieldbyname('nick_usuario').AsString + ')');
    mensajeTexto.Add ('Departamento: ' + incidenciaObtenerDepartamentoUsuario(codigoIncidencia));

    if tipo = 'tecnico' then
      mensajeTexto.Add ('Recurso: ' + obtenerNombre(md.tc3.fieldbyname('codigorecurso').AsInteger, vtTablaRecurso));
    mensajeTexto.Add ('Estado: ' + md.tc3.fieldbyname('estado').AsString);
    mensajeTexto.Add ('Asunto: ' + md.tc3.fieldbyname('asunto').AsString);
    mensajeTexto.Add ('Tcnico responsable: ' + md.tc3.fieldbyname('Tecnico_nombre').AsString);
    mensajeTexto.Add ('Prioridad usuario: ' + md.tc3.fieldbyname('prioridadusuario').AsString);
    if tipo = 'tecnico' then
    begin
      mensajeTexto.Add ('Prioridad aplicacin: ' + md.tc3.fieldbyname('prioridad').AsString);
    end;

    mensajeTexto.Add('');
    mensajeTexto.Add ('Descripcin:');
    mensajeTexto.Add('');
    mensajeTexto.Add(md.tc3.fieldbyname('incidencia').AsString);
    if md.tc3.fieldbyname('completado').AsInteger = 100 then
    begin
      mensajeTexto.Add('');
      mensajeTexto.Add('');
      mensajeTexto.Add('Fecha resolucin: ' + md.tc3.fieldbyname('fecharesolucion').AsString);
      if tipo = 'tecnico' then
      begin
        mensajeTexto.Add('Texto resolucin: ');
        mensajeTexto.Add('');
        mensajeTexto.Add(md.tc3.fieldbyname('incidenciaresolucion').AsString);
        mensajeTexto.Add('');
        mensajeTexto.Add('');
        mensajeTexto.Add('-----------------------------');
        mensajeTexto.Add(vtEmpresaNombre);
        mensajeTexto.Add(vtEmpresaDireccion);
        mensajeTexto.Add(vtEmpresaTelefono);
      end;
    end;

    if mostrarFormulario then
    begin
      Application.createform(TFormEnvioEmail, FormEnvioEmail);
      if tipo = 'tecnico' then
      begin
        formEnvioEmail.envioTecnico := true;
        formEnvioEmail.codigoDepartamento := -1
      end
      else
      begin
        formEnvioEmail.envioTecnico := false;
        formEnvioEmail.codigoDepartamento :=
            incidenciaObtenerCodigoDepartamentoUsuario (codigoIncidencia);
      end;

      formEnvioEmail.Tag := codigoIncidencia;
      formEnvioEmail.txtAsunto.Text := asunto;
      formEnvioEmail.txtCuerpo.Text := mensajeTexto.Text;
      if tipo = 'usuario' then
        formEnvioEmail.txtEmailDestinatario.Text :=
              obtenerEmail (md.tc3.fieldbyname('codigousuario').AsInteger,
              vtTablaUsuario, 'email')
      else
        formEnvioEmail.txtEmailDestinatario.Text :=
              obtenerEmail (md.tc3.fieldbyname('codigotecnico').AsInteger,
              vtTablaUsuario, 'email');
      if obtenerDatosUsuario (vtCodigoUsuario, emailFormulario, nombreFormulario) then
      begin
        formEnvioEmail.txtNombreEmisor.Text := nombreFormulario;
        formEnvioEmail.txtEmailEmisor.Text := emailFormulario;
      end
      else
      begin
        formEnvioEmail.txtNombreEmisor.Text := md.tc3.fieldbyname('Tecnico_nombre').AsString;
        formEnvioEmail.txtEmailEmisor.Text := vtEmailUsuario;
      end;
      FormEnvioEmail.showmodal;
    end;
  end;
end;

procedure insertarLogIncidencia (codigoUsuarioAlta : integer; accion : string;
    fecha : TDateTime; codigoIncidencia : integer; fechaInicio : TDateTime;
    fechaFin : TDateTime; valorTexto : string;
    valorNumerico : integer;    automatico : string; observacion : string);
begin
  with md.tcI do
  begin
    Close;
    SQL.Clear;
    SQL.Add('INSERT INTO ' + vtTablaIncidenciasLog +
        ' (codigousuario, accion, fecha, valortexto, observacion, ' +
        ' codigoincidencia, fechafin, fechainicio, valornumerico, automatico) ' +
        ' VALUES (:pCodigoUsuario, :pAccion, :pFecha, :pValorTexto, ' +
        ':pObservacion, :pCodigoIncidencia, :pFechaFin, :pFechaInicio, ' +
        ':pValorNumerico, :pAutomatico)');
    ParamByName('pCodigoUsuario').DataType := ftInteger;
    ParamByName('pCodigoUsuario').AsInteger := codigoUsuarioAlta;
    ParamByName('pAccion').DataType := ftString;
    ParamByName('pAccion').AsString := accion;
    ParamByName('pFecha').DataType := ftDateTime;
    ParamByName('pFecha').AsDateTime := fecha;
    ParamByName('pValorTexto').DataType := ftString;
    ParamByName('pValorTexto').AsString := valorTexto;
    ParamByName('pObservacion').DataType := ftString;
    ParamByName('pObservacion').AsString := observacion;
    ParamByName('pCodigoIncidencia').DataType := ftInteger;
    ParamByName('pCodigoIncidencia').AsInteger := codigoIncidencia;
    ParamByName('pFechaFin').DataType := ftDateTime;
    ParamByName('pFechaFin').AsDateTime := fechaFin;
    ParamByName('pFechaInicio').DataType := ftDateTime;
    ParamByName('pFechaInicio').AsDateTime := fechaInicio;
    ParamByName('pValorNumerico').DataType := ftInteger;
    ParamByName('pValorNumerico').AsInteger := valorNumerico;
    ParamByName('pAutomatico').DataType := ftString;
    ParamByName('pAutomatico').AsString := automatico;
    try
      ExecSQL;
      Close;
    except
      //---------silenciosa-----------
    end;
  end;
end;

procedure incidenciaResolver (codigoIncidencia : integer;
    textoResolucion : string; motivoResolucion : string; fechaResolucion : TDate;
    horaResolucion : TTime; tiempoEmpleado : integer);
var
  hora, minuto, segundo, milisegundo : Word;
  ano, mes, dia : Word;
  fechaHoraResolucion : TDateTime;
  codigoMotivoResolucion : integer;
begin
  DecodeTime(horaResolucion, hora, minuto, segundo, milisegundo);
  DecodeDate(fechaResolucion, ano, mes, dia);
  fechaHoraResolucion := EncodeDateTime(ano, mes, dia, hora, minuto, segundo, milisegundo);
  codigoMotivoResolucion := obtenerCodigoMotivoResolucion (motivoResolucion);
  with md.tcI do
  begin
    Close;
    SQL.Clear;
    SQL.Add('UPDATE ' + vtTablaIncidencia + ' SET ');
    SQL.Add('  incidenciaresolucion = :pincidenciaresolucion, ');
    SQL.Add('  fecharesolucion = :pfecharesolucion, ');
    SQL.Add('  estado = :pestado, ');
    SQL.Add('  completado = :pcompletado, ');
    SQL.Add('  aceptada = :paceptada, ');
    SQL.Add('  resueltatecnico = :presueltatecnico,');
    SQL.Add('  tiempoempleado = :pTiempoEmpleado,');
    SQL.Add('  codigoincidenciaresolucion = :pCodigoMotivoResolucion');
    SQL.Add('  where codigo = :pCodigo');
    ParamByName('pincidenciaresolucion').DataType := ftString;
    ParamByName('pincidenciaresolucion').AsString := textoResolucion;
    ParamByName('pfecharesolucion').DataType := ftDateTime;
    ParamByName('pfecharesolucion').AsDateTime := fechaHoraResolucion;
    ParamByName('pestado').DataType := ftString;
    ParamByName('pestado').AsString := 'Resuelto pendiente confirmacin';
    ParamByName('pcompletado').DataType := ftInteger;
    ParamByName('pcompletado').AsInteger := 100;
    ParamByName('paceptada').DataType := ftString;
    ParamByName('paceptada').AsString := 'S';
    ParamByName('presueltatecnico').DataType := ftString;
    ParamByName('presueltatecnico').AsString := 'S';
    ParamByName('pCodigo').DataType := ftInteger;
    ParamByName('pCodigo').AsInteger := codigoIncidencia;
    ParamByName('pTiempoEmpleado').DataType := ftInteger;
    ParamByName('pTiempoEmpleado').AsInteger := tiempoEmpleado;
    ParamByName('pCodigoMotivoResolucion').AsInteger := codigoMotivoResolucion;
    try
      ExecSQL;
      Close;
    except
      //---------silenciosa-----------
    end;
  end;
end;

procedure incidenciaReabrir (codigoIncidencia : integer;
    textoResolucion : string);
begin
  with md.tcI do
  begin
    Close;
    SQL.Clear;
    SQL.Add('UPDATE ' + vtTablaIncidencia + ' SET ');
    SQL.Add('  incidenciaresolucion = :pincidenciaresolucion, ');
    SQL.Add('  estado = :pestado, ');
    SQL.Add('  completado = :pcompletado, ');
    SQL.Add('  aceptada = :paceptada, ');
    SQL.Add('  resueltatecnico = :presueltatecnico,');
    SQL.Add('  confirmada = :pConfirmada,');
    SQL.Add('  reaperturas = (COALESCE(reaperturas, 0) + 1)');
    SQL.Add('  where codigo = :pCodigo');
    ParamByName('pincidenciaresolucion').DataType := ftString;
    ParamByName('pincidenciaresolucion').AsString := textoResolucion;
    ParamByName('pestado').DataType := ftString;
    ParamByName('pestado').AsString := 'Pendiente valoracin';
    ParamByName('pcompletado').DataType := ftInteger;
    ParamByName('pcompletado').AsInteger := 0;
    ParamByName('paceptada').DataType := ftString;
    ParamByName('paceptada').AsString := 'N';
    ParamByName('pConfirmada').DataType := ftString;
    ParamByName('pConfirmada').AsString := 'N';
    ParamByName('presueltatecnico').DataType := ftString;
    ParamByName('presueltatecnico').AsString := 'N';
    ParamByName('pCodigo').DataType := ftInteger;
    ParamByName('pCodigo').AsInteger := codigoIncidencia;
    try
      ExecSQL;
      Close;
    except
      //---------silenciosa-----------
      close;
    end;
  end;
end;

procedure incidenciaDesestimar (codigoIncidencia : integer;
    textoResolucion : string);
begin
  with md.tcI do
  begin
    Close;
    SQL.Clear;
    SQL.Add('UPDATE ' + vtTablaIncidencia + ' SET ');
    SQL.Add('  estado = :pestado, ');
    SQL.Add('  completado = :pcompletado, ');
    SQL.Add('  aceptada = :paceptada, ');
    SQL.Add('  resueltatecnico = :presueltatecnico, ');
    SQL.Add('  fecharesolucion = :pFechaResolucion ');
    SQL.Add('  where codigo = :pCodigo');
    ParamByName('pestado').DataType := ftString;
    ParamByName('pestado').AsString := 'Desestimado';
    ParamByName('pcompletado').DataType := ftInteger;
    ParamByName('pcompletado').AsInteger := 100;
    ParamByName('paceptada').DataType := ftString;
    ParamByName('paceptada').AsString := 'S';
    ParamByName('presueltatecnico').DataType := ftString;
    ParamByName('presueltatecnico').AsString := 'S';
    ParamByName('pCodigo').DataType := ftInteger;
    ParamByName('pCodigo').AsInteger := codigoIncidencia;
    ParamByName('pFechaResolucion').DataType := ftDateTime;
    ParamByName('pFechaResolucion').AsDateTime := now;
    try
      ExecSQL;
      Close;
    except
      //---------silenciosa-----------
      close;
    end;
  end;
end;


procedure incidenciaAceptar (codigoIncidencia : integer);
begin
  with md.tcI do
  begin
    Close;
    SQL.Clear;
    SQL.Add('UPDATE ' + vtTablaIncidencia + ' SET ');
    SQL.Add('  aceptada = :pAceptada, ');
    SQL.Add('  estado = :pEstado ');
    SQL.Add('  where codigo = :pCodigo');
    ParamByName('pAceptada').DataType := ftString;
    ParamByName('pAceptada').AsString := 'S';
    ParamByName('pEstado').DataType := ftString;
    ParamByName('pEstado').AsString := 'En curso';
    ParamByName('pCodigo').DataType := ftInteger;
    ParamByName('pCodigo').AsInteger := codigoIncidencia;
    try
      ExecSQL;
      Close;
    except
      //---------silenciosa-----------
    end;
  end;
end;

procedure incidenciaConfirmar (codigoIncidencia : integer);
begin
  with md.tcI do
  begin
    Close;
    SQL.Clear;
    SQL.Add('UPDATE ' + vtTablaIncidencia + ' SET ');
    SQL.Add('  confirmada = :pConfirmada, ');
    SQL.Add('  estado = :pEstado, ');
    SQL.Add('  fechaconfirmacion = :pFechaConfirmacion');
    SQL.Add('  where codigo = :pCodigo');
    ParamByName('pConfirmada').DataType := ftString;
    ParamByName('pConfirmada').AsString := 'S';
    ParamByName('pEstado').DataType := ftString;
    ParamByName('pEstado').AsString := 'Resuelto';
    ParamByName('pCodigo').DataType := ftInteger;
    ParamByName('pCodigo').AsInteger := codigoIncidencia;
    ParamByName('pFechaConfirmacion').DataType := ftInteger;
    ParamByName('pFechaConfirmacion').AsDateTime := now;
    try
      ExecSQL;
      Close;
    except
      //---------silenciosa-----------
    end;
  end;
end;

function permisosMenuUsuario (codigousuario, codigomenu,
    tipoPermiso : integer; mostrarAviso : boolean) : boolean;
var
  permisoModificacion : string;
  permisoInsercion : string;
  permisoEliminacion : string;
  permisoLectura : string;
  permisoTodos : string;
  permisoExportar : string;
  permisoResolverTecnico : string;
  permisoReasignar : string;
  permisoConfirmarUsuario : string;
  permisoReabrirIncidencia : string;
  permisoTareaIncidencia : string;
begin
  if (vtUsuarioTipo = 'Superusuario') or (vtAdministradorUsuario = true) then
    Result := true
  else
  begin
    md.tc3.Close;
    md.tc3.SQL.Clear;
    md.tc3.SQL.Add('select permisomodificacion, permisoeliminacion, permisolectura, ');
    md.tc3.SQL.Add('  permisoinsercion, permisotodos, permisoexportar, ');
    md.tc3.SQL.Add('permisoresolverincidenciatecnico, permisoreasignarincidencia, ');
    md.tc3.SQL.Add('permisoconfirmarincidenciausuario, permisoReabrirIncidencia, permisoTareaIncidencia');
    md.tc3.SQL.Add('from ' + vtTablaUsuarioMenu);
    md.tc3.SQL.Add('where codigousuario = :pCodigoUsuario and codigomenu=:pCodigoMenu');
    md.tc3.ParamByName('pCodigoUsuario').DataType := ftInteger;
    md.tc3.ParamByName('pCodigoUsuario').AsInteger := codigousuario;
    md.tc3.ParamByName('pCodigoMenu').DataType := ftInteger;
    md.tc3.ParamByName('pCodigoMenu').AsInteger := codigomenu;
    md.tc3.Open;
    permisoModificacion := md.tc3.fieldbyname('permisomodificacion').AsString;
    permisoInsercion := md.tc3.fieldbyname('permisoinsercion').AsString;
    permisoEliminacion := md.tc3.fieldbyname('permisoeliminacion').AsString;
    permisoLectura := md.tc3.fieldbyname('permisolectura').AsString;
    permisoTodos := md.tc3.fieldbyname('permisotodos').AsString;
    permisoExportar := md.tc3.fieldbyname('permisoexportar').AsString;
    permisoResolverTecnico := md.tc3.fieldbyname('permisoresolverincidenciatecnico').AsString;
    permisoReasignar := md.tc3.fieldbyname('permisoreasignarincidencia').AsString;
    permisoConfirmarUsuario := md.tc3.fieldbyname('permisoconfirmarincidenciausuario').AsString;
    permisoReabrirIncidencia := md.tc3.fieldbyname('permisoReabrirIncidencia').AsString;
    permisoTareaIncidencia := md.tc3.fieldbyname('permisoTareaIncidencia').AsString;

    if permisoTodos = 'S' then
      Result := true
    else
    begin
      case tipoPermiso of
        1 : Result := permisoLectura = 'S';
        2 : Result := permisoModificacion = 'S';
        3 : Result := permisoInsercion = 'S';
        4 : Result := permisoEliminacion = 'S';
        6 : Result := permisoExportar = 'S';
        7 : Result := permisoResolverTecnico = 'S';
        8 : Result := permisoReasignar = 'S';
        9 : Result := permisoConfirmarUsuario = 'S';
        10 : Result := permisoReabrirIncidencia = 'S';
        11 : Result := permisoTareaIncidencia = 'S';
      else
        Result := false;
      end;
    end;
    md.tc3.close;
    if not Result and mostrarAviso then
    begin
      MessageDlg('No tiene permisos para realizar esta accin.',
          mtWarning, [mbok], 0);
    end;
  end;
end;


function obtenerHash (texto : string) : string;
var
  MD5Digest : TMD5Digest;
  hashMD5 : TLbMD5;
begin
  hashMD5 := TLbMD5.Create(nil);
  hashMD5.HashString(texto);
  hashMD5.GetDigest(MD5Digest);
  result := BufferToHex(MD5Digest, SizeOf(MD5Digest));
end;  

procedure reestablecerValoresTabla (ventana : string);
begin
  eliminarClaveRegistro (vtClaveRegistroConfiguracion + ventana, HKEY_CURRENT_USER);
end;

function eliminarClaveRegistro (clave : string; claveRoot : Cardinal) : boolean;
var
  reg : TRegistry;
begin
  Reg := TRegistry.Create;
  with Reg do
  try
    RootKey := claveRoot;
    Result := DeleteKey(clave);
  finally
    Free;
  end;
end;


function permisoAccesoMenu (opcionMenu : Integer; avisar : boolean) : boolean;
begin
  result := false;
  { TODO : Falta por implementar los permisos para acceder a las opciones de men }
  if vtUsuarioTipo = 'Superusuario' then
    Result := true
  else
  begin
    {if permisosMenuUsuario(vtCodigoUsuario, opcionMenu) = 'Lectura/Escritura'

    if opcion = 'Usuarios' then
    begin
      if vtAdministradorUsuario or (vtUsuarioTipo = 'Tcnico') then
        Result := true
      else
      begin
        Result := false;
        if avisar then
          MessageDlg('No tiene permisos para acceder a esta opcin de men.',
              mtWarning, [mbok], 0);
      end;
    end;

    if opcion = 'Series' then
    begin
      if vtAdministradorUsuario then
        Result := true
      else
      begin
        Result := false;
        if avisar then
          MessageDlg('No tiene permisos para acceder a esta opcin de men.',
              mtWarning, [mbok], 0);
      end;
    end;


    if opcion = 'UtilidadesBD' then
    begin
      if vtAdministradorUsuario then
        Result := true
      else
      begin
        Result := false;
        if avisar then
          MessageDlg('No tiene permisos para acceder a esta opcin de men.',
              mtWarning, [mbok], 0);
      end;
    end;}

  end;
end;

function permisoModificacion (opcion : string; avisar : boolean) : boolean;
begin
  Result := vtModificacionUsuario;
  if not Result and avisar then
    MessageDlg('No tiene permisos para realizar esta accin.',
        mtWarning, [mbok], 0);
end;

function enviarEmailClientePredeterminado (const asunto, cuerpo,
    rutaFicheroAdjunto, nombreEmisor, emailEmisor,
    nombreReceptor, emailReceptor : string) : integer;
var
  message: TMapiMessage;
  lpSender,
  lpRecepient: TMapiRecipDesc;
  FileAttach: TMapiFileDesc;
  SM: TFNMapiSendMail;
  MAPIModule: HModule;
begin
  FillChar(message, SizeOf(message), 0);
  with message do
  begin
    if (asunto <> '') then
    begin
      lpszSubject := PChar(asunto)
    end;
    if (cuerpo <> '') then
    begin
      lpszNoteText := PChar(cuerpo)
    end;
    if (emailEmisor <> '') then
    begin
      lpSender.ulRecipClass := MAPI_ORIG;
      if (nombreEmisor = '') then
      begin
        lpSender.lpszName := PChar(emailEmisor)
      end
      else
      begin
        lpSender.lpszName := PChar(nombreEmisor)
      end;
      lpSender.lpszAddress := PChar('SMTP:' + emailEmisor);
      lpSender.ulReserved := 0;
      lpSender.ulEIDSize := 0;
      lpSender.lpEntryID := nil;
      lpOriginator := @lpSender;
    end;
    if (emailReceptor <> '') then
    begin
      lpRecepient.ulRecipClass := MAPI_TO;
      if (nombreReceptor = '') then
      begin
        lpRecepient.lpszName := PChar(emailReceptor)
      end
      else
      begin
        lpRecepient.lpszName := PChar('')
      end;
      lpRecepient.lpszAddress := PChar('SMTP:' + emailReceptor);
      lpRecepient.ulReserved := 0;
      lpRecepient.ulEIDSize := 0;
      lpRecepient.lpEntryID := nil;
      nRecipCount := 1;
      lpRecips := @lpRecepient;
    end
    else
    begin
      lpRecips := nil
    end;
    if (rutaFicheroAdjunto = '') then
    begin
      nFileCount := 0;
      lpFiles := nil;
    end
    else
    begin
      FillChar(FileAttach, SizeOf(FileAttach), 0);
      FileAttach.nPosition := Cardinal($FFFFFFFF);
      FileAttach.lpszPathName := PChar(rutaFicheroAdjunto);
      nFileCount := 1;
      lpFiles := @FileAttach;
    end;
  end;
  MAPIModule := LoadLibrary(PChar(MAPIDLL));
  if MAPIModule=0 then
  begin
    Result := -1
  end
  else
  begin
    try
      @SM := GetProcAddress(MAPIModule, 'MAPISendMail');
      if @SM<>nil then
      begin
        Result := SM(0, Application.Handle, message, MAPI_DIALOG or
                     MAPI_LOGON_UI, 0);
      end
      else
      begin
        Result := 1
      end;

    finally
      FreeLibrary(MAPIModule);
    end;
  end;
  if Result<>0 then
  begin
    MessageDlg('Error al enviar email ('+IntToStr(Result)+').', mtError, [mbOk],
               0)
  end;
end;  

procedure insertarAdjunto (nombreTabla : string; codigoBus : string;
   fichero : string);
begin
  application.createform(TformGestionDocumental, formGestionDocumental);
  formGestionDocumental.Tag := 10;
  formGestionDocumental.txtID.Text := codigoBus;
  formGestionDocumental.txtTabla.ItemIndex :=
      formGestionDocumental.txtTabla.Items.IndexOf(nombreTabla);
  formGestionDocumental.txtRuta.Text := fichero;
  formGestionDocumental.txtNombre.Text := ExtractFileName(fichero);
  formGestionDocumental.txtTabla.Enabled := false;
  formGestionDocumental.txtID.Enabled := false;
  formGestionDocumental.showmodal;
end;


//Devuelve true si la serie ha de mostrarse en el nmero
function mostrarNumSerie (serie : string; tablaM : string) : Boolean;
begin
  result := false;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('select mostrarennumero from ' + vtTablaSerie);
  md.tc2.SQL.Add('where upper(nombre) = :pNombre and upper(tabla) = :pTabla');
  md.tc2.ParamByName('pTabla').DataType := ftString;
  md.tc2.ParamByName('pTabla').AsString := tablaM;
  md.tc2.ParamByName('pNombre').DataType := ftString;
  md.tc2.ParamByName('pNombre').AsString := serie;
  try
    md.tc2.Open;
    if md.tc2.RecordCount > 0 then
      Result := md.tc2.FieldByName('mostrarennumero').AsString = 'S'
    else
      Result := false;
  except
  end;
  md.tc2.Close;
end;

//llena una cadena con un nmero de caracteres determinado
function llenarCadena (cadena : string;
     numero : integer;
     caracter : Char;
     derecha : Boolean) : string;
begin
  while Length(cadena) < numero do
  begin
    if derecha then
      cadena := cadena + caracter
    else
      cadena := caracter + cadena;
  end;
  llenarCadena := cadena;
end;

function cargarSeries (tabla : string) : TStringList;
begin
  md.tc.Close;
  md.tc.SQL.Clear;
  md.tc.SQL.Add('select distinct(nombre) from ' + vtTablaSerie);
  if tabla <> '' then
  begin
    md.tc.SQL.Add('where tabla=:ptabla');
    md.tc.ParamByName('pTabla').DataType := ftString;
    md.tc.ParamByName('pTabla').AsString := tabla;
  end;
  try
    md.tc.Open;
  except
  end;
  Result := TStringList.Create;
  while not md.tc.Eof do
  begin
    Result.Add (md.tc.FieldByName('nombre').AsString);
    md.tc.Next;
  end;
  md.tc.Close;
end;

function obtenerLista (tabla : string; campo : string) : TStringList;
begin
  md.tc.Close;
  md.tc.SQL.Clear;
  md.tc.SQL.Add('select distinct( ' + campo + ') from ' + tabla);
  try
    md.tc.Open;
    Result := TStringList.Create;
    while not md.tc.Eof do
    begin
      Result.Add (md.tc.FieldByName(campo).AsString);
      md.tc.Next;
    end;
    md.tc.Close;
  except
    md.tc.Close;  
    //silenciosa
  end;
end;


function obtenerTipoSolicitud (todas : Boolean) : TStringList;
begin
  Result := TStringList.Create;
  
  md.tc5.Close;
  md.tc5.SQL.Clear;
  md.tc5.SQL.Add('select distinct(nombre) from ' + vtTablaIncidenciaTipo);
  if not todas then
  begin
    md.tc5.SQL.Add('where mostrar = :pMostrar');
    md.tc5.ParamByName('pMostrar').DataType := ftString;
    md.tc5.ParamByName('pMostrar').AsString := 'S';
  end;
  try
    md.tc5.Open;
    while not md.tc5.Eof do
    begin
      Result.Add (md.tc5.FieldByName('nombre').AsString);
      md.tc5.Next;
    end;
    md.tc5.Close;
  except
    md.tc5.Close;
  end;
end;

function obtenerDiasVtoCliente (codigo : integer) : Integer;
begin
  md.tc3.Close;
  md.tc3.SQL.Clear;
  md.tc3.SQL.Add('select f.dias from ' + vtTablaTercero + ' t, ' +
      vttablaFormaPago + ' f');
  md.tc3.SQL.Add('where t.codigo = :pCodigo and t.codigoformapago=f.codigo');
  md.tc3.ParamByName('pCodigo').DataType := ftInteger;
  md.tc3.ParamByName('pCodigo').AsInteger := codigo;
  md.tc3.Open;
  Result := md.tc3.fieldbyname('dias').AsInteger;
  md.tc3.close;
end;

procedure obtenerValorParametro (nombre : string;
    var valor1 : string; var valor2 : string);
begin
  md.tc.Close;
  md.tc.SQL.Clear;
  md.tc.SQL.Add('SELECT valor, valor2');
  md.tc.SQL.Add('FROM ' + vtTablaParametro);
  md.tc.SQL.Add('WHERE nombre = :pNombre');
  md.tc.ParamByName('pNombre').DataType := ftinteger;
  md.tc.ParamByName('pNombre').AsString := nombre;
  md.tc.Open;
  valor1 := md.tc.FieldByName('valor').AsString;
  valor2 := md.tc.FieldByName('valor2').AsString;  
  md.tc.Close;
end;

function ejecutarProceso (nombreProceso : string) : Cardinal;
var
  infoInicio : TStartupInfo;
  infoProceso : TProcessInformation;
begin
  Result := 0;

  FillChar (infoInicio, SizeOf(infoInicio), 0);
  infoInicio.cb := SizeOf(infoInicio);

  if CreateProcess(PChar(nombreProceso), nil,
      nil, nil, false, 0, nil, nil,
      infoInicio, infoProceso) then
    Result := infoProceso.hProcess;
end;

procedure ejecutarEsperar (aplicacion : string);
var
  numProceso : Cardinal;
begin
  Application.Minimize;
  numProceso := ejecutarProceso (aplicacion);
  if numProceso <> 0 then
    WaitForSingleObject(numProceso, INFINITE);
  Application.Restore;
end;

function marcarTelefono (telefono : string; puerto : string) : boolean;
var
  numeroTelefono : string;
  numeroBytesEscritos : cardinal;
begin
  numeroTelefono := 'ATDT ' + telefono + #13 + #10;
  ficheroComunicacion := CreateFile(PChar(puerto), GENERIC_WRITE, 0, nil, OPEN_EXISTING,
      FILE_ATTRIBUTE_NORMAL, 0);
  if ficheroComunicacion = INVALID_HANDLE_VALUE then
    Result := false
  else
  begin
    numeroBytesEscritos := 0;
    if WriteFile (ficheroComunicacion, PChar(numeroTelefono)^, Length(numeroTelefono),
        numeroBytesEscritos, nil) = false then
      Result := false
    else
      result := true;
  end;
end;

procedure colgarLlamada ();
begin
  try
    CloseHandle(ficheroComunicacion);
  except
  end;
end;


//Comprobar integridad referencial
function comprobarIntegridad (tabla : string; campo : string;
    codigo : integer) : boolean;
begin
  md.tc.Close;
  md.tc.SQL.Clear;
  md.tc.SQL.Add('SELECT count(Codigo) NumeroT');
  md.tc.SQL.Add('FROM ' + tabla);
  md.tc.SQL.Add('WHERE ' + campo + ' = :pCodigo');
  md.tc.ParamByName('pcodigo').DataType := ftinteger;
  md.tc.ParamByName('pcodigo').AsInteger := codigo;
  md.tc.Open;
  Result := md.tc.FieldByName('NumeroT').value > 0;
  md.tc.Close;
end;


//devolver verdadero si hay algn registro en la tabla con el valor del campo
//especificados
function existeRegistro (tabla : string; campo : string; valor : integer) : boolean;
begin
  result := false;
  md.tcI.SQL.Clear;
  md.tcI.SQL.Add('SELECT count(Codigo) NumeroT');
  md.tcI.SQL.Add('FROM ' + tabla);
  md.tcI.SQL.Add('WHERE ' + campo  + ' = :pcodigo');
  md.tcI.ParamByName('pcodigo').DataType := ftinteger;
  md.tcI.ParamByName('pcodigo').AsInteger := valor;
  try
    md.tcI.Open;
    result := md.tcI.FieldByName('NumeroT').AsInteger > 0;
  except
    md.tcI.Close;
  end;
end;


function anoFecha (fecha : TDate) : Integer;
var
  vano, vmes, vdia : word;
begin
  DecodeDate (fecha, vano, vmes, vdia);
  result := vano;
end;

function obtenerNumeroFactura () : string;
var
  vano, vmes, vdia : word;
  i : integer;
  numFactura : string;
  numFacturaAuto : integer;
begin
  DecodeDate (date, vano, vmes, vdia);
  numFacturaAuto := generarCodigoAuto (vtTablaFactura);
  for i := 1 to vtCantidadCarFac - length(inttostr(numFacturaAuto))  do
  begin
    numFactura := '0' + numFactura;
  end;
  numFactura := numFactura + IntToStr(numFacturaAuto);
  Result := '';
  for i := 1 to 3 do
  begin
    case vtOrdenNumFactura[i] of
      1 : Result := Result + numFactura;
      2 : Result := Result + vtSerieFactura;
      3 : Result := Result + vtAnoFactura;
    end;
  end;
end;  


function tamanoFichero (sFileToExamine: string) : Integer;
var
  SearchRec: TSearchRec;
  sgPath: string;
  inRetval, I1: Integer;
begin
  sgPath := ExpandFileName(sFileToExamine);
  try
    inRetval := FindFirst(ExpandFileName(sFileToExamine), faAnyFile, SearchRec);
    if inRetval = 0 then
      I1 := SearchRec.Size
    else
      I1 := -1;
  finally
    SysUtils.FindClose(SearchRec);
  end;
  Result := I1;
end;


function obtenerPrecioArticulo (codigo : integer; var nombreMaterial : string) : Double;
begin
  Result := 0;
  nombreMaterial := '';
  md.TC2.Close;
  md.TC2.SQL.Clear;
  md.TC2.SQL.Add('Select t.precioventa, t.nombre');
  md.TC2.SQL.Add ('from ' + vtTablaArticulo + ' t');
  md.TC2.SQL.Add ('where t.codigo = :pCodigo');
  md.TC2.ParamByName('pCodigo').DataType := ftInteger;
  md.TC2.ParamByName('pCodigo').AsInteger := codigo;
  try
    md.TC2.Open;
    result := md.tc2.fieldbyname('precioventa').AsFloat;
    nombreMaterial := md.tc2.fieldbyname('nombre').asString;
  except
  end;
end;


function obtenerDatosUsuario (codigo : integer;
    var email : string; var nombre : string) : boolean;
begin
  Result := false;
  md.TC2.Close;
  md.TC2.SQL.Clear;
  md.TC2.SQL.Add('Select u.nombre, u.email');
  md.TC2.SQL.Add ('from ' + vttablaUsuario + ' u');
  md.TC2.SQL.Add ('where u.codigo = :pCodigo');
  md.TC2.ParamByName('pCodigo').DataType := ftInteger;
  md.TC2.ParamByName('pCodigo').AsInteger := codigo;
  try
    md.TC2.Open;
    if md.tc2.RecordCount > 0 then
    begin
      email := md.tc2.fieldbyname('email').AsString;
      nombre := md.tc2.fieldbyname('nombre').AsString;
      Result := true;
    end;
  except
    result := false;
  end;
end;


function obtenerEmailContacto (codigo : integer) : string;
begin
  result := '';
  md.TC2.Close;
  md.TC2.SQL.Clear;
  md.TC2.SQL.Add('Select c.emailempresa1, c.emailempresa2, c.emailparticular1, c.emailparticular2');
  md.TC2.SQL.Add ('from ' + vtTablaContacto + ' c');
  md.TC2.SQL.Add ('where c.codigo = :pCodigo');
  md.TC2.ParamByName('pCodigo').DataType := ftInteger;
  md.TC2.ParamByName('pCodigo').AsInteger := codigo;
  try
    md.TC2.Open;
    if md.tc2.RecordCount > 0 then
      if md.tc2.fieldbyname('emailempresa1').AsString <> '' then
        Result := md.tc2.fieldbyname('emailempresa1').AsString
      else
        if md.tc2.fieldbyname('emailempresa2').AsString <> '' then
          Result := md.tc2.fieldbyname('emailempresa2').AsString
        else
          if md.tc2.fieldbyname('emailparticular1').AsString <> '' then
            Result := md.tc2.fieldbyname('emailparticular1').AsString
          else
            if md.tc2.fieldbyname('emailparticular1').AsString <> '' then
              Result := md.tc2.fieldbyname('emailparticular1').AsString;
  except
    result := '';
  end;
end;

function obtenerPrecioHoraCliente (codigo : integer; var porcDto : Double; var desplazamiento : double) : Double;
begin
  porcDto := 0;
  desplazamiento := 0;
  Result := 0;
  md.TC.Close;
  md.TC.SQL.Clear;
  md.TC.SQL.Add('Select t.preciohora, t.porcentajedto, t.preciodesplazamiento');
  md.TC.SQL.Add ('from ' + vtTablaTercero + ' t');
  md.TC.SQL.Add ('where t.codigo = :pCodigo');
  md.TC.ParamByName('pCodigo').DataType := ftInteger;
  md.TC.ParamByName('pCodigo').AsInteger := codigo;
  try
    md.TC.Open;
    result := md.tc.fieldbyname('preciohora').AsFloat;
    porcDto := md.tc.fieldbyname('porcentajedto').AsFloat;
    desplazamiento := md.tc.fieldbyname('preciodesplazamiento').AsFloat;
  except
  end;
end;


function actualizarParteFacturado (codigo : integer; facturado,
    numerofactura : string; codigofactura : integer) : boolean;
begin
  result := false;
  md.tc.Close;
  md.tc.SQL.Clear;
  md.tc.SQL.Add('update ' + vtTablaParte + ' set ' +
      'facturado = :pFacturado, ' +
      'codigofactura = :pCodigoFactura, ' +
      'numfactura = :pNumFactura ' +
      'where codigo = :pCodigo');
  md.tc.ParamByName('pFacturado').DataType := ftString;
  md.tc.ParamByName('pFacturado').Value := facturado;
  md.tc.ParamByName('pCodigo').DataType := ftString;
  md.tc.ParamByName('pCodigo').Value := codigo;
  md.tc.ParamByName('pCodigoFactura').DataType := ftInteger;
  md.tc.ParamByName('pCodigoFactura').Value := codigofactura;
  md.tc.ParamByName('pNumFactura').DataType := ftString;
  md.tc.ParamByName('pNumFactura').Value := numerofactura;
  try
    md.tc.ExecSQL;
    result := md.tc.RowsAffected > 0;
  except
  end;
end;

function obtenerMySQLTablas () : TStringList;
var
  lista : TStringList;
begin
  lista := TStringList.Create;
  md.tc.Close;
  md.tc.SQL.Clear;
  md.tc.SQL.Add('SHOW TABLES');
  try
  md.tc.Open;
    while not md.tc.Eof do
    begin
      lista.Add (md.tc.Fields[0].AsString);
      md.tc.Next;
    end;
    Result := lista;
  except
    Result := lista;
  end;
  md.tc.Close;  
end;

//Funcin para conectar con el servidor de email
function ConectarServidorEmail (servidor : string; usuario : string; puerto : integer) : boolean;
begin
  compEnvioEmail := TIdSMTP.Create(nil);
  compEnvioEmail.host := servidor;
  compEnvioEmail.userid := usuario;
  compEnvioEmail.Port := puerto;
  try
    compEnvioEmail.connect;
    ConectarServidorEmail := true;
  except
    compEnvioEmail.Free;
    raise;
  end;
end;

//enviar email
function enviarEmail (servidor : string; usuario : string; contrasena : string;
    puerto : integer; asunto : string; mensaje : TStringList; conAutenticacion : boolean;
    emisor : string; nombreEmisor : string; destinatario : string; cc : string) : boolean;
var
  compMensaje : TIdMessage;
  envioCorrecto : boolean;
begin
  if conAutenticacion then
  begin
    compEnvioEmail.AuthenticationType := atLogin;
    compEnvioEmail.UserId := usuario;
    compEnvioEmail.Password := contrasena;
  end
  else
    compEnvioEmail.AuthenticationType := atNone;
  compMensaje := TIdMessage.Create (nil);

  destinatario := AnsiReplaceStr(destinatario,';',',');

  compMensaje.Recipients.EMailAddresses := destinatario;

  compMensaje.From.Address := emisor;
  compMensaje.From.Name := nombreEmisor;

  if cc <> '' then
    compMensaje.CCList.Add.Address := cc;
  compMensaje.Body.AddStrings (mensaje);
  compMensaje.Subject := asunto;
  compMensaje.ReplyTo.Add.Address := emisor;
  envioCorrecto := true;
  try
    compEnvioEmail.Send(compMensaje);
  except
    raise;
  end;
  compMensaje.Free;
  enviarEmail := envioCorrecto;
end;



//Genera el cdigo de la tabla especificada automticamente
function generarCodigoAuto (tabla : string) : integer;
var
  contador : integer;
begin
  result := 1;
  with md.tcContador do
  begin
    Close;
    SQL.Clear;  //obtenemos el contador de la tabla contadores
    SQL.Add('SELECT *');
    SQL.Add('FROM ' + vtTablaContador);
    SQL.Add('WHERE tabla = :pTabla');
    ParamByName('pTabla').DataType := ftString;
    ParamByName('pTabla').AsString := tabla;
    Open;
    if not (md.tcContador.FieldByName('Contador').AsInteger = 0) then
    begin
      try
        contador := FieldByName('contador').AsInteger + 1;
        //Incrementamos el contador de la tabla contadores
        Close;
        SQL.Clear;
        SQL.Add('UPDATE ' + vtTablaContador +
            ' SET contador = :pContador WHERE tabla = :pTabla');
        ParamByName('pContador').DataType := ftInteger;
        ParamByName('pContador').AsInteger := contador;
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').AsString := tabla;
        ExecSQL;
        close;
        result := contador;
      except
        Close;
        result := 1;
        MessageDlg ('El cdigo no ha podido generarse automticamente.', mtError, [mbOK], 0);
      end;
    end
    else  //si no existe el registro de contador para la tabla actual, lo creamos
    begin
      try
        Close;
        SQL.Clear;
        SQL.Add('INSERT INTO ' + vtTablaContador +
            ' (tabla, contador) ' +
            ' VALUES (:pTabla, 1)');
        ParamByName('pTabla').DataType := ftString;
        ParamByName('pTabla').AsString := tabla;
        ExecSQL;
        result := 1;
        Close;
      except
        Close;
        MessageDlg ('El contador no se ha guardado correctamente.', mtError, [mbOK], 0);
      end;
    end;
  end;
end;




function obtenerNombre (codigo : integer; tabla : string) : string;
begin
  result := '';
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('SELECT Codigo, Nombre ' + ' FROM ' + tabla +
      ' WHERE codigo = :pCodigo');
  md.TC2.ParamByName('pCodigo').AsInteger := codigo;
  md.TC2.Open;
  if md.TC2.RecordCount > 0 then
    result := md.TC2.fieldbyname('Nombre').AsString;
  md.tc2.Close;
end;

function obtenerCampo (codigo : integer; tabla : string;
    campo : string) : string;
begin
  result := '';
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('SELECT ' + campo + ' FROM ' + tabla +
      ' WHERE codigo = :pCodigo');
  md.TC2.ParamByName('pCodigo').AsInteger := codigo;
  md.TC2.Open;
  if md.TC2.RecordCount > 0 then
    result := md.TC2.fieldbyname(campo).AsString;
  md.tc2.Close;
end;

function obtenerDepartamentoTecnicoSubcategoria (codigo : integer) : integer;
begin
  result := 0;
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('SELECT codigodepartamento ' + ' FROM ' + vttablaSubCategoria +
      ' WHERE codigo = :pCodigo');
  md.TC2.ParamByName('pCodigo').AsInteger := codigo;
  md.TC2.Open;
  if md.TC2.RecordCount > 0 then
    result := md.TC2.fieldbyname('codigodepartamento').AsInteger;
  md.tc2.Close;
end;


function obtenerEmail (codigo : integer; tabla : string; campo : string) : string;
begin
  md.tc2.Close;
  md.tc2.SQL.Clear;
  md.tc2.SQL.Add('SELECT ' + campo + ' FROM ' + tabla +
      ' WHERE codigo = :pCodigo');
  md.TC2.ParamByName('pCodigo').AsInteger := codigo;
  md.TC2.Open;
  if md.TC2.RecordCount > 0 then
    result := md.TC2.fieldbyname(campo).AsString
  else
    result := '';
  md.tc2.Close;
end;


//Actualiza el stock de los artculos (facturas clientes - salidas / facturas proveedores - entradas
procedure actualizarStock (entrada : boolean; cantidad : double; codigo : Integer);
begin
  with md.tcStock do
  begin
    close;
    SQL.Clear;
    SQL.Add('UPDATE ' + vtTablaArticulo);
    if entrada then
      SQL.Add('SET stock = stock + :pCantidad')
    else
      SQL.Add('SET stock = stock - :pCantidad');
    SQL.Add('WHERE Codigo = :pCodigo');
    ParamByName('pCantidad').DataType := ftFloat;
    ParamByName('pCantidad').AsFloat := cantidad;
    ParamByName('pCodigo').DataType := ftInteger;
    ParamByName('pCodigo').AsInteger := codigo;
    try
      execsql;
    except
      Raise;
    end;
    close;
  end;
end;


//inserta un registro en la tabla especificada con el campo nombre=valor
//devuelve el cdigo del registro insertado
function insertarvalor (valor : string; tabla : string) : integer;
begin
  with md.tcIndeterminado do
  begin
    Close;
    SQL.Clear;
    SQL.Add('SELECT count(codigo) cuenta FROM ' + tabla + ' WHERE nombre = ' + QuotedStr(AnsiUpperCase(valor)));
    Open;
    if fieldbyname('cuenta').asinteger = 0 then
    begin
      close;
      SQL.Clear;
      SQL.Add('INSERT INTO ' + tabla + ' (nombre) VALUES (' + QuotedStr(valor) + ')');
      ExecSQL;
      close;
    end;
    close;
    SQL.Clear;
    SQL.Add('SELECT codigo FROM ' + tabla + ' WHERE nombre = ' + QuotedStr(AnsiUpperCase(valor)));
    open;
    result := fieldbyname('codigo').AsInteger;
    close;
  end;
end;



//obtiene el valor del campo y la tabla especificados
function obtenerValor (campo : string; tabla : string; valor : Integer) : string;
begin
  Result := '';
  with md.tcIndeterminado do
  begin
    Close;
    SQL.Clear;
    SQL.Add('SELECT ' + campo + ' FROM ' + tabla + ' WHERE codigo = ' + inttostr(valor));
    Open;
    Result := fieldbyname(campo).AsString;
    close;
  end;
end;



function comprobarDuplicado (nombre : string; tabla : string; campo : string) : boolean;
begin
  with md.tc do
  begin
    Close;
    SQL.Clear;
    SQL.Add('SELECT COUNT(' + campo + ') Contador');
    SQL.Add('FROM ' + tabla);
    SQL.Add('WHERE UPPER(' + campo + ') = :pNombre');
    ParamByName('pNombre').DataType := ftString;
    ParamByName('pNombre').AsString := AnsiUpperCase(nombre);
    Open;
    result := FieldByName('Contador').AsInteger > 0;
    close;
  end;
end;


function SeleccionarCarpeta (titulo : string) : string;
var
  Inf: TBrowseInfo;
  Identificador: PItemIDList;
  Gestor : IMalloc;
  Carpeta : Array[0..MAX_PATH] Of Char;
 // handle : THandle;
begin
  With Inf Do
  Begin
    //hwndOwner := Handle;
    pidlRoot := Nil;
    pszDisplayName := Carpeta;
    lpszTitle := pchar(titulo);
    ulFlags := BIF_BROWSEINCLUDEFILES;
    lpfn := Nil;
  End;
  Identificador := SHBrowseForFolder(Inf);
  If Identificador <> Nil Then
  Begin
    SHGetPathFromIDList(Identificador, Carpeta);
    SHGetMalloc(Gestor);
    Gestor.Free(Identificador);
    SeleccionarCarpeta := Carpeta
  end;
end;


//lee un valor booleano de un fichero INI
function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readbool (clave, cadena, defecto);
  finally
    free;
  end;
end;

//lee un valor numrico de un fichero INI
function leNumINI (clave, cadena : string; defecto : Integer) : Integer;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadInteger (clave, cadena, defecto);
  finally
    free;
  end;
end;

//lee un valor string de un fichero INI
function leCadINI (clave, cadena : string; defecto : String) : String;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := ReadString (clave, cadena, defecto);
  finally
    free;
  end;
end;

//escribe un valor string en un fichero INI
procedure esCadINI (clave, cadena : string; valor : String);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteString (clave, cadena, valor);
  finally
    free;
  end;
end;

//escribe un valor boolean en un fichero INI
procedure esBoolINI (clave, cadena : string; valor : Boolean);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteBool (clave, cadena, valor);
  finally
    free;
  end;
end;

//escribe un valor numrico en un fichero INI
procedure esNumINI (clave, cadena : string; valor : Integer);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    WriteInteger (clave, cadena, valor);
  finally
    free;
  end;
end;


//encriptar datos
function encriptar (Str, Clave : String) : String;
var
  Src: TStringStream;
  Dst: TMemoryStream;
  Size: Integer;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
begin
  Result:= EmptyStr;
  Src:= TStringStream.Create(Str);
  try
    Dst:= TMemoryStream.Create;
    try
      // Preparamos la clave, lo ideal es que tenga 32 caracteres
      FillChar(Key,Sizeof(Key),#0);
      if Length(Clave) > Sizeof(Key) then
        move(PChar(Clave)^,Key,Sizeof(key))
      else
        move(PChar(Clave)^,Key,Length(Clave));
      AEsExpandKey(ExpandedKey,Key);
      // Guardamos el tamao del texto original
      Size:= Src.Size;
      Dst.WriteBuffer(Size,Sizeof(Size));
      // Ciframos el texto
      AESEncryptStreamECB(Src,Dst,ExpandedKey);
      // Lo codificamos a base64
      Result:= BinToStr(Dst.Memory,Dst.Size);
    finally
      Dst.Free;
    end;
  finally
    Src.Free;
  end;
end;

//desencriptar datos
function desencriptar (Str, Clave : String): String;
var
  Src: TMemoryStream;
  Dst: TStringStream;
  Size: Integer;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
begin
  Result:= EmptyStr;
  Src:= TMemoryStream.Create;
  try
    Dst:= TStringStream.Create(Str);
    try
      StrToStream(Str, Src);
      Src.Position:= 0;
      FillChar(Key,Sizeof(Key),#0);
      if Length(Clave) > Sizeof(Key) then
        move(PChar(Clave)^,Key,Sizeof(key))
      else
        move(PChar(Clave)^,Key,Length(Clave));
      AESExpandKey(ExpandedKey,Key);
      // Leemos el tamao del texto
      try
        Src.ReadBuffer(Size,Sizeof(Size));
        AESDecryptStreamECB(Src,Dst,ExpandedKey);
        Dst.Size:= Size;
        Result:= Dst.DataString;
      except
        Result := '';
      end;
    finally
      Dst.Free;
    end;
  finally
    Src.Free;
  end;
end;


procedure cargarConfiguracion ();
var
  contrasenaMDB : string;
begin
  vtCodigoLog := -1;
  vtCodigoCategoriaSel := -1;
  vtCodigoMarcaSel := -1;
  vtTipoBDMySQL := leBoolINI('Base de datos', 'Tipo BD MySQL', false);
  vtBDMySQLNombreBD := leCadINI('Base de datos', 'Tipo BD MySQL - Nombre BD', '');
  vtBDMySQLServidor := leCadINI('Base de datos', 'Tipo BD MySQL - Servidor', '');
  vtBDMySQLPedirUsuario := leBoolINI('Base de datos', 'Tipo BD MySQL - Pedir usuario al inicio', false);
  vtBDMySQLProtocolo := leCadINI('Base de datos', 'Tipo BD MySQL - Protocolo', 'mysql-4.1');
  vtBDMySQLPuerto := leCadINI('Base de datos', 'Tipo BD MySQL - Puerto', '3306');
  //vtContrasena := desencriptar (leCadINI('Base de datos', 'Tipo BD MySQL - Contrasea', ''), 450);
  vtContrasena := leCadINI('Base de datos', 'Tipo BD MySQL - Contrasea', '');
  //vtUsuario := leCadINI('Base de datos', 'Tipo BD MySQL - Usuario', '');

  vtDefectoTipo := leCadINI('Defecto', 'Tipo tercero', 'Cliente');
  vtDefectoCambioControl := leBoolINI('Defecto', 'Cambio control intro', true);

  vtDuplicadoNombreArticulo := leBoolINI('Defecto', 'Permitir duplicado - Nombre articulo', true);
  vtDuplicadoNombreTercero := leBoolINI('Defecto', 'Permitir duplicado - Nombre tercero', true);

  vtClaveElegida := -1;
  vtTipoBDMySQL := true;

  vtIndeterminado := leCadINI('Defecto', 'Valor indeterminado', 'Indeterminado');

  vtEmpresaNombre := leCadINI('Empresa', 'Nombre', '');
  vtEmpresaDireccion := leCadINI('Empresa', 'Direccin', '');
  vtEmpresaCIF := leCadINI('Empresa', 'CIF', '');
  vtEmpresaProvincia := leCadINI('Empresa', 'Provincia', '');
  vtEmpresaPoblacion := leCadINI('Empresa', 'Poblacin', '');
  vtEmpresaNombrePersona := leCadINI('Empresa', 'Nombre persona', '');
  vtEmpresaTelefono := leCadINI('Empresa', 'Telfono', '');
  vtEmpresaInscripcion := leCadINI('Empresa', 'Inscripcin', '');
  vtEmpresaLogotipo := leCadINI('Empresa', 'Logotipo', '');
  vtEmpresaLogotipoNombre := leCadINI('Empresa', 'Logotipo Nombre', '');
  vtEmpresaCP := leCadINI('Empresa', 'CP', '');
  vtEmpresaObservacion := leCadINI('Empresa', 'Observacin', '');

  vtCodigoClienteFacturas := leNumINI('Defecto', 'Cdigo cliente defecto facturas', 1);
  vtCodigoProveedorFacturas := leNumINI('Defecto', 'Cdigo proveedor defecto facturas', 1);
  vtCrearFacturaAuto := leBoolINI('Defecto', 'Crear factura automticamente', true);
  vtPorcentajeIVAFactura := leNumINI('Defecto', 'Porcentaje IVA facturas', 16);

  vtArticulosCodFamilia := leNumINI('Defecto', 'Artculo - Cdigo familia', 1);
  vtArticulosCodModelo := leNumINI('Defecto', 'Artculo - Cdigo modelo', 1);
  vtArticulosCodMarca := leNumINI('Defecto', 'Artculo - Cdigo marca', 1);
  vtArticulosCodProveedor := leNumINI('Defecto', 'Artculo - Cdigo proveedor', 1);
  vtCodT1 := leNumINI ('Defecto', 'Tcnico 1', 1);
  vtCodT2 := leNumINI ('Defecto', 'Tcnico 2', 1);
  vtCodT3 := leNumINI ('Defecto', 'Tcnico 3', 1);
  vtCodT4 := leNumINI ('Defecto', 'Tcnico 4', 1);
  vtCodT5 := leNumINI ('Defecto', 'Tcnico 5', 1);
  vtCodT6 := leNumINI ('Defecto', 'Tcnico 6', 1);
  vtCodTecnicoInd := leNumINI('Defecto', 'Tcnico indeterminado', 1);
  vtDefectoCodRecurso := leNumINI('Defecto', 'Incidencia - Cdigo recurso', 0);
  vtDefectoCodCliente := leNumINI('Defecto', 'Incidencia - Cdigo cliente', 0);
  vtDefectoPrioridad := leNumINI('Defecto', 'Incidencia - Prioridad', 5);
  vtDefectoIncidenciaTipo := leCadINI('Defecto', 'Incidencia - Tipo', 'Asistencia tcnica');

  vtTamanoFicheroAdjunto := leNumINI('Fichero Adjunto', 'Tamao mximo', 2097152);

  vtCantidadCarFac := leNumINI('Facturacin', 'Cantidad de caracteres del nmero de factura', 4);
  vtSerieFactura := leCadINI('Facturacin', 'Serie', 'A');
  vtAnoFactura := leCadINI('Facturacin', 'Ao', '/' + IntToStr(YearOf(Date)));
  vtOrdenNumFactura[leNumINI('Facturacin', 'Orden 1', 1)] := 1;
  vtOrdenNumFactura[leNumINI('Facturacin', 'Orden 2', 2)] := 2;
  vtOrdenNumFactura[leNumINI('Facturacin', 'Orden 3', 3)] := 3;
  vtOcultarPieFactura := leBoolINI('Facturacin', 'Ocultar pie factura', false);
  vtOcultarPieObservacion := leBoolINI('Facturacin', 'Ocultar pie observacin', false);
  vtFacturasSerie := leCadINI('Facturacin', 'Serie por defecto', 'A');


  vtEmailServidor := leCadINI('Servidor email', 'Servidor', '');
  vtEmailUsuario := leCadINI('Servidor email', 'Usuario', '');
  vtEmailContrasena := desencriptar (leCadINI('Servidor email', 'Contrasea', ''), claveEncriptacionTexto);
  vtEmailPuerto := leCadINI('Servidor email', 'Puerto', '');
  vtEmailCuenta := leCadINI('Servidor email', 'Cuenta', '');
  vtEmailAutenticacion := leBoolINI('Servidor email', 'Autenticacin', false);   
  vtTituloVentanaPartesTrabajo := leCadINI('Ttulo ventanas', 'Partes de trabajo', 'Parte de trabajo');
  vtTituloVentanaIncidencias := leCadINI('Ttulo ventanas', 'Incidencias', 'Incidencia');
  vtTituloVentanaPartesTrabajoPlural :=  leCadINI('Ttulo ventanas', 'Partes de trabajo - Plural', 'Partes de trabajo');
  vtTituloVentanaIncidenciasPlural :=  leCadINI('Ttulo ventanas', 'Incidencias - Plural', 'Incidencias');
  vtTituloVentanaPartesTrabajoBoton := leCadINI('Ttulo ventanas', 'Partes de trabajo - Botn', 'Partes');
  vtTituloVentanaPartesTrabajoMenu := leCadINI('Ttulo ventanas', 'Partes de trabajo - Men', 'Partes de trabajo');

  vtColorIncidenciasPrioridadMedia := leNumINI('Colores', 'Incidencias - Prioridad Media', 8454143);
  vtColorIncidenciasPrioridadBaja := leNumINI('Colores', 'Incidencias - Prioridad Baja', 8454016);
  vtColorIncidenciaPrioridadAlta := leNumINI('Colores', 'Incidencias - Prioridad Alta', 8421631);
  vtColorIncidenciaReaperturas := leNumINI('Colores', 'Incidencias - Reaperturas', 15921906);  
  vtColorIncidenciasFuenteSeleccionada := leNumINI('Colores', 'Incidencias - Fuente seleccionada', 9999999);
  vtColorIncidenciasFuenteNoSeleccionada := leNumINI('Colores', 'Incidencias - Fuente no seleccionada', 0000000);
  vtColorIncidenciasPorFuente := leBoolINI('Colores', 'Por fuente (no por fondo)', true);
  vtColorIncidenciasSeleccion := leNumINI('Colores', 'Incidencias - Fondo seleccin', 32896);

  vtRutaAplicacionControlRemoto := leCadINI('Mantenimiento', 'Ruta Informacin Usuarios Terminal Server', '');

  vtSoloIncidenciasUsuario := usuarioMostrarSusIncidencias (vtCodigoUsuario);

  vtRutaMDBInventario := leCadINI('Mantenimiento', 'Ruta MDB inventario', '');
  contrasenaMDB := leCadINI('Mantenimiento', 'Contrasea MDB inventario', '');
  if contrasenaMDB <> '' then
    vtContrasenaMDB := desencriptar (contrasenaMDB, claveEncriptacionTexto)
  else
    vtContrasenaMDB := '';

  vtIncidenciaAvisoConfirmar := leBoolINI('Mantenimiento', 'Mostrar aviso antes de confirmar una incidencia por el tcnico', true);
  vtIncidenciaReasignarAsociado := leBoolINI('Mantenimiento', 'Permitir reasignar slo por el tcnico asignado', true);

  vtTiempoComprobacionNotificacion := leNumINI('Aviso incidencias nuevas', 'Tiempo comprobacin notificacin', 10);
  vtNotificarIncidenciasNuevas := leBoolINI('Aviso incidencias nuevas', 'Notificar incidencias nuevas', false);
  vtAvisoIncidenciasUnaVez := leBoolINI('Aviso incidencias nuevas', 'Avisar slo una vez', false);

  vtIncidenciaEnviarEmail :=
      leBoolINI('Incidencias', 'Enviar email de notificacin', false);
  vtIncidenciaAsignacionAutomatica :=
      leBoolINI('Incidencias', 'Asignacin automtica de la incidencia', true);
  vtIncidenciaAnadirOtra :=
      leBoolINI('Incidencias', 'Aadir otra incidencia', false);

  vtIncidenciaMostrarFechaInferior :=
     leBoolINI('Incidencias', 'Mostrar incidencias resueltas con fecha inferior a', true);

  vtNumMesesMostrarIncidencias :=
     leNumINI('Incidencias', 'Meses a mostrar incidencias antiguas', 2);

  vtCodigoTemp := 0;
end;

function obtenerCadenaRegistro (claveInicial : Cardinal; clave : string; valor : string) : string;
var
  reg: TRegistry;
begin
  Result := '';
  Reg := TRegistry.Create;
  Reg.RootKey := claveInicial;
  reg.OpenKey(clave, False);
  try
    Result := reg.ReadString(valor);
  finally
    reg.CloseKey;
  end;
end;

procedure obtenerDatosODBC (odbc : string; sistema : boolean;
    var bd : string; var tipo : string; var descripcion : string;
    var controlador : string; var servidor : string;
    var listener : string; var usuario : string);
var
  claveInicial : Cardinal;
begin
  bd := '';
  tipo := '';
  descripcion := '';
  controlador := '';
  servidor := '';
  listener := '';
  usuario := '';
  if sistema then
    claveInicial := HKEY_LOCAL_MACHINE
  else
    claveInicial := HKEY_CURRENT_USER;
  tipo := obtenerCadenaRegistro(claveInicial,'SOFTWARE\ODBC\ODBC.INI\ODBC Data Sources',odbc);

  //Oracle
  if pos ('ORACLE', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    listener := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'ServerName');
    usuario := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'UserID');
  end;
  //MySQL
  if pos ('MYSQL', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DESCRIPTION');
    bd := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DATABASE');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    servidor := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'SERVER');
    usuario := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'UID');
  end;
  //MS Access
  if pos ('ACCESS', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    bd := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DBQ');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    usuario := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'UID');
  end;
  //DBASE
  if pos ('DBASE', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
  end;
  //SQL SERVER
  if pos ('SQL SERVER', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    servidor := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Server');
    usuario := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'LastUser');
  end;
  //Paradox
  if pos ('PARADOX', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    bd := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DefaultDir');
    servidor := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc + '\Engines\Paradox', 'ParadoxNetPath');
    usuario := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'LastUser');
  end;
  //Excel
  if pos ('EXCEL', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    bd := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DBQ');
    servidor := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DefaultDir');
  end;
  //TEXT, CSV
  if pos ('TEXT', AnsiUpperCase (tipo)) > 0 then
  begin
    descripcion := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Description');
    controlador := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'Driver');
    bd := obtenerCadenaRegistro(claveInicial, 'SOFTWARE\ODBC\ODBC.INI\' + odbc, 'DefaultDir');
  end;
end;

                   
procedure conectarBD ();
//var
//  f : tform;
begin
 { if vtTipoBDMySQL then
  begin
    if (vtUsuario = '') or (vtBDMySQLServidor = '') or (vtBDMySQLProtocolo = '') then
      MessageDlg('Debe configurar el tipo de base de datos al que se conectar.',
          mtWarning, [mbok], 0)
    else
    begin
      with md.bd do
      begin
        Connected := false;
        LoginPrompt := false;
        if vtBDMySQLPedirUsuario then
        begin
          F := application.findcomponent('formIncioSesion') as TForm;
          if Assigned(F) then
              f.showmodal
          else
          begin
            //application.createform(tformIncioSesion, formIncioSesion);
            if vtTipoBDMySQL then
            begin
              //formIncioSesion.txtBD.Text := vtBDMySQLNombreBD;
              //formIncioSesion.txtTipoBD.Text := 'MySQL';
            end;
            //formIncioSesion.showmodal;
          end;
        end;
        md.bd.Protocol := vtBDMySQLProtocolo;
        HostName := vtBDMySQLServidor;
        Port := strtoint(vtBDMySQLPuerto);
        Database := vtBDMySQLNombreBD;
        User := vtUsuario;
        Password := vtContrasena;
        try
          Connected := true;
        except
          //EZSQLException
          on e : exception do
          begin
            MessageDlg ('No se ha podido conectar con el servidor: [' + vtBDMySQLServidor +
                ']. Compruebe que el servicio de MySQL est iniciado y que ha ' +
                'escrito correctamente el nombre del servidor.' + chr(13) + chr(13) +
                'A continuacin la descripcin completa del error:' + chr(13) +
                e.ClassName + chr(13) + e.Message,
                mtError, [mbok], 0);
            formmenuprincipal.be.Panels[1].Text := 'No conectado';
            Exit;
          end;
        end;
      end;
    end;
  end;}
  formMenuPrincipal.Caption := Application.Title + ' v. ' + vtVersionAplicacion;
  formmenuprincipal.be.Panels[1].Text := vtUsuarioAcceso;
  formmenuprincipal.be.Panels[2].Text := vtBDMySQLServidor + '@' + vtBDMySQLNombreBD;
end;

//Leer valor del Regedit
function leeRegistro (desdeClave : HKEY; ruta, cadena : string;
                      crear : boolean) : string;
var
  reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := desdeClave;
    Reg.OpenKey(ruta, crear);
    leeRegistro := Reg.ReadString(cadena);
  finally
    reg.Free;
  end;
end;


//Escribe valor en el Regedit
procedure escribeRegistro (desdeClave : HKEY; ruta, cadena, valor : string;
                      crear : boolean);
var
  reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := desdeClave;
    Reg.OpenKey(ruta, crear);
    Reg.WriteString(cadena, valor);
  finally
    reg.Free;
  end;
end;



{function ejecutarFichero (fichero : string) : boolean;
begin
  result := true;
  if ShellExecute(handle, Nil, PChar(fichero),
      Nil, Nil, SW_SHOWNORMAL) <= 32 then
  begin
    result := false;
  end;
end;}


end.
